<?php

namespace backend\modules\reports\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use backend\modules\reports\models\GstReport;
use backend\modules\users\models\Invoice;

use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use yii\debug\models\timeline\DataProvider;

class GstReportController extends Controller{
    
    public function actionIndex(){
        //print_r($from_date1);die();
        $searchModel= new GstReport();
        $to_date=date('Y-m-d');
        $from_date=date('Y-m-d');
        $from=date('m-Y');
        $to=date('m-Y');
        
        $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();

        $sql=Yii::$app->db->createCommand("CALL gstr_2(:params_1)")
        ->bindValue(':params_1',$to_date)
        ->queryAll();
        if(Yii::$app->request->get()) {   
            $searchModel->load(Yii::$app->request->queryParams);
            $from_date=$searchModel->to_date ."-01";
            $lastday=date('t',strtotime($from_date));
            $to_date=$searchModel->to_date .-$lastday;
            //$prev_date=$searchModel->to_date .-$lastday;
            
            $from=$searchModel->from_date ;
            $to=$searchModel->to_date ;
          
            Yii::$app->session->set('time',$to);
            //$time=Yii::$app->session->get('time');
           //print_r($time);die();
            $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
            //print_r($query);die();

            $sql = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
            // print_r($from_date);
            // print_r($to_date);die();

        }
        
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        //print_r($dataProvider->models);die();
        $dataProvider1 = new ArrayDataProvider([
            'allModels'=>$sql,
        ]);
        //print_r($dataProvider1->models);die();
        $total_amt_outward=0;
        $total_tax_outward=0;
        foreach($dataProvider->models as $model){
            $total_amt_outward=$total_amt_outward+$model['taxable_amount'];
            $total_tax_outward=$total_tax_outward+$model['total_tax'];  
        }
        //print_r($total_tax_outward);die();
        $total_tax_inward=0;
        foreach($dataProvider1->models as $model){
            $total_tax_inward=$total_tax_inward+$model['cgst']+$model['sgst']+$model['igst'];  
        }
        //print_r($total_tax);die();
    
        return $this->render('index',
        [   
            'total_tax_outward'=>$total_tax_outward,
            'total_amt_outward'=>$total_amt_outward,
            'total_tax_inward'=>$total_tax_inward,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'from'=>$from,
            'to'=>$to,
            'searchModel'=>$searchModel
    
        ]);
    }
    public function actionGstr3($from_date1=null,$to_date1=null){
        //print_r($from_date);die();
        $searchModel= new GstReport();
        // print_r(1);die();
        if(!$from_date1 && !$to_date1){
        $from_date=date('Y-m-d');
        $to_date=date('Y-m-d');
        $from=date('m-Y');
        $to=date('m-Y');
        }
        else{
            $from_date=$from_date1;
            $to_date=$to_date1;
            $from=date('F  Y', strtotime($from_date1));
            $to=date('F  Y', strtotime($to_date1)); 
        }
        $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        $sql = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        if(Yii::$app->request->get()) {
            $searchModel->load(Yii::$app->request->queryParams);
            //print_r($from_date);die();
            if($from_date1!=null && $to_date1!=null){
            $from_date=$from_date1;
            $to_date=$to_date1;
            $from=date('F  Y', strtotime($from_date1));
            $to=date('F  Y', strtotime($to_date1));
            
            }
            else{
            //print_r(1);die();
            $from_date=$searchModel->from_date ."-01";
            //$lastday=date('t',strtotime($from_date));
            $from=$searchModel->from_date ;
            $to=$searchModel->to_date ;
            $lastday=date('t',strtotime($to));
            $to_date=$searchModel->to_date .-$lastday;

            }

            $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
            $sql = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();

        }
        
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        //print_r($dataProvider->models);die();
        $dataProvider1 = new ArrayDataProvider([
            'allModels'=>$sql,
        ]);
        //print_r($dataProvider1->models);die();
        $total_amt_outward=0;
        $total_tax_outward=0;
        foreach($dataProvider->models as $model){
            $total_amt_outward=$total_amt_outward+$model['taxable_amount'];
            $total_tax_outward=$total_tax_outward+$model['total_tax'];  
        }
        //print_r($total_tax_outward);die();
        $total_amt_inward=0;
        $total_tax_inward=0;
        foreach($dataProvider1->models as $model){
            $total_amt_inward=$total_amt_inward+$model['subtotal'];
            $total_tax_inward=$total_tax_inward+$model['cgst']+$model['sgst']+$model['igst'];  
        }
        //print_r($total_tax);die();
    
        return $this->render('gstr3-b',
        [   'total_amt_outward'=>$total_amt_outward,
            'total_tax_outward'=>$total_tax_outward,
            'total_amt_inward'=>$total_amt_inward,
            'total_tax_inward'=>$total_tax_inward,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'from'=>$from,
            'to'=>$to,
            'searchModel'=>$searchModel
    
        ]);
        
    }

    public function actionGstr3b($from_date=null,$to_date=null,$print=null,$from_month=null){
        $searchModel= new GstReport();
        //print_r($print);die();
        // print_r(1);die();
        if($from_date==null && $to_date==null){
        $from_date=date('Y-m-d');
        $to_date=date('Y-m-d');
        $from=date('m-Y');
        $to=date('m-Y');
        }
        else{
        $from_date=$from_date;
        $to_date=$to_date;
        $from=date('F  Y', strtotime($from_date));
        $to=date('F  Y', strtotime($to_date));
        }
        //print_r($from_date);die();
        $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        $sql = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        if(Yii::$app->request->get()) {
            $searchModel->load(Yii::$app->request->queryParams);
            // $from_date=$searchModel->from_date ."-18";
            // $from=$searchModel->from_date ;
            // $to_date=$searchModel->to_date ."-18";
            // $to=$searchModel->to_date ;
            $from_date=$from_date;
            $to_date=$to_date;
            $from=$from;
            $to=$to;
            $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
            $sql = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();

        }
        
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        //print_r($dataProvider->models);die();
        $dataProvider1 = new ArrayDataProvider([
            'allModels'=>$sql,
        ]);
        //print_r($dataProvider1->models);die();
        $taxable_amount=0;
        $igst=0;
        $cgst=0;
        $sgst=0;
        foreach($dataProvider->models as $model){
            $taxable_amount=$taxable_amount+$model['taxable_amount'];
            $igst=$igst+$model['igst_amount'];
            $cgst=$cgst+$model['cgst_amount'];  
            $sgst=$sgst+$model['sgst_amount'];  
            
        }

        //print_r($igst);die();
        $subtotal=0;
        $igst1=0;
        $cgst1=0;
        $sgst1=0;
        foreach($dataProvider1->models as $model){
            $subtotal=$subtotal+$model['subtotal'];
            $igst1=$igst+$model['igst'];
            $cgst1=$cgst+$model['cgst'];  
            $sgst1=$sgst+$model['sgst'];  
        }
        //print_r($total_tax);die();
        if($print==true){
            //print_r(1);die();
            $mpdf = new mpdf;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/gst-report/exportpdf',
            [   
                'taxable_amount'=> $taxable_amount,
                'igst'=>$igst,
                'cgst'=>$cgst,
                'sgst'=>$sgst,
                'subtotal'=>$subtotal,
                'igst1'=>$igst1,
                'cgst1'=>$cgst1,
                'sgst1'=>$sgst1,
                'from_date'=>$from_date,
                'to_date'=>$to_date,
                'from'=>$from,
                'to'=>$to,
                'from_month'=>$from_month,
    
                'searchModel'=>$searchModel
        
            ]));
            
        
       
            $mpdf->Output('GST_Report.pdf', 'I');
            
        }
    
        return $this->render('gstr3b',
        [   
            'taxable_amount'=> $taxable_amount,
            'igst'=>$igst,
            'cgst'=>$cgst,
            'sgst'=>$sgst,
            'subtotal'=>$subtotal,
            'igst1'=>$igst1,
            'cgst1'=>$cgst1,
            'sgst1'=>$sgst1,
            'from'=>$from,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'to'=>$to,

            'searchModel'=>$searchModel
    
        ]);
        
    }

    public function actionGstr1($from_date=null,$to_date=null){
        $searchModel= new GstReport();
        if($from_date==null && $to_date==null){
        $from_date=date('Y-m-d');
        $to_date=date('Y-m-d');
        $current_month = date("m");
        $current_year = date("Y");
        $from=date('F  Y', strtotime($to_date));
        $to=date('F  Y', strtotime($to_date));
        }
        else{
            $from_date=$from_date;
            $to_date=$to_date;
            $from=date('F  Y', strtotime($from_date));
            $to=date('F  Y', strtotime($to_date));
        }
        //print_r($from_date);die();
        
        
        $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        // $query=Invoice::find()->select('sub_total_price','igst_amount','cgst_amount','sgst_amount')
        // ->where(['is_deleted'=>0])->all();
        //print_r($query);die();
        
        // $from=$searchModel->from_date ;
        
        // $to=$searchModel->to_date ;
        if(Yii::$app->request->get()) {
            $searchModel->load(Yii::$app->request->queryParams);
          // print_r($searchModel->load(Yii::$app->request->queryParams));die();
            $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
            $from_date=$from_date;
            $to_date=$to_date;
            $from=$from;
            $to=$to;
        }

        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        //print_r($dataProvider->models);die();
        $taxable_amount=0;
        $igst=0;
        $cgst=0;
        $sgst=0;
        foreach($dataProvider->models as $model){
            $taxable_amount=$taxable_amount+$model['taxable_amount'];
            $igst=$igst+$model['igst_amount'];
            $cgst=$cgst+$model['cgst_amount'];  
            $sgst=$sgst+$model['sgst_amount'];  
            
        }
        //print_r($sum_tax);die();
        return $this->render('gstr1',
        [   
            'dataProvider'=>$dataProvider,
            'searchModel'=>$searchModel,
            'taxable_amount'=> $taxable_amount,
            'igst'=>$igst,
            'cgst'=>$cgst,
            'sgst'=>$sgst,
            'from'=>$from,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'to'=>$to,

        ]); 
    }

    public function actionGstr2($from_date=null,$to_date=null){
        $searchModel= new GstReport();
        if($from_date==null && $to_date==null){
        $from_date=date('Y-m-d');
        $to_date=date('Y-m-d');
        $from=date('m-Y');
        $to=date('m-Y');
        }
        else{
            $from_date=$from_date;
            $to_date=$to_date;
            $from=date('F  Y', strtotime($from_date));
            $to=date('F  Y', strtotime($to_date));
        }
        $query = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        if(Yii::$app->request->get()) {
            //print_r(1);die();
            $searchModel->load(Yii::$app->request->queryParams);
            $from_date=$from_date;
            $to_date=$to_date;
            // $from_date=$searchModel->from_date ."-18";
            // //print_r($from_date);die();
            // $to_date=$searchModel->to_date ."-18";
            // $from=$searchModel->from_date ;
            // $to=$searchModel->to_date ;
            $from=$from;
            $to=$to;
          // print_r($searchModel->load(Yii::$app->request->queryParams));die();
            $query = Yii::$app->db->createCommand("CALL gstr(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
        }
        //print_r($query);die();
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
        ]);
        //print_r($dataProvider->models);die();

        $subtotal=0;
        $igst=0;
        $cgst=0;
        $sgst=0;
        foreach($dataProvider->models as $model){   
            $subtotal=$subtotal+$model['subtotal'];
            $igst=$igst+$model['igst'];
            $cgst=$cgst+$model['cgst'];  
            $sgst=$sgst+$model['sgst'];  
        }
        return $this->render('gstr2',
        [   'from'=>$from,
            'to'=>$to,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'subtotal'=>$subtotal,
            'igst'=>$igst,
            'cgst'=>$cgst,
            'sgst'=>$sgst,
            'searchModel'=>$searchModel]); 
    }
    public function actionExportPdf(){
       
            //print_r(1);die();
            //$data->pagination = false;
            //print_r($taxable_amount);die();
            
            $mpdf = new \Mpdf\Mpdf(['tempDir' => __DIR__ . '/custom/temp/dir/path']);
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/gst-report/exportpdf'));
            
        
       
            $mpdf->Output('GST_Report.pdf', 'D');
        
    }

}
?>