<?php

namespace backend\modules\reports\controllers;

use Yii;
use backend\modules\reports\models\Gstr1Details;
use backend\modules\reports\models\Gstr1Creditnotes;
use backend\modules\reports\models\Gstr3Outward;

use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii2tech\spreadsheet\Spreadsheet;
use yii\filters\VerbFilter;
use backend\modules\users\models\InvoiceProduct;
use backend\modules\users\models\Invoice;
use backend\modules\master\models\Product;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Vendor;
use backend\modules\users\models\CreditNote;
use backend\modules\users\models\CreditNoteProduct;
use backend\modules\master\models\HsnCode;

use yii\db\Query;
use Mpdf\Mpdf;

class Gstr1DetailsController extends \yii\web\Controller
{
    public function actionIndex($print=null,$excel=null,$from_date=null,$to_date=null,$datefrom=null)
    {

        $model = new Gstr1Details();
        // print_r($datefrom);
        // die();
        if($from_date==null && $to_date==null && $datefrom==null)
        {
            $current_month = date("m");
            $current_year = date("Y");
            $from_date = $current_year.'-'.$current_month.'-01';
            $to_date = $current_year.'-'.$current_month.'-30';
        }
        else if($datefrom!='')
        {   
            // print_r('ww');
            // die();
            $from_date = $datefrom;
            $to_date = $datefrom;
            $current_month = date("m",strtotime($to_date));
            $current_year = date("Y",strtotime($to_date));
            $from_date = $current_year.'-'.$current_month.'-01';
        }
        else
        {
            $from_date = $from_date;
            $to_date = $to_date;
            $current_month = date("m",strtotime($to_date));
            $current_year = date("Y",strtotime($to_date));
        }
        

        // print_r($from_date);
        // die();
        if($current_month== '2')
        {
            if(($current_year/4) == 0)
              $to_date = $current_year.'-'.$current_month.'-29';
            else
              $to_date = $current_year.'-'.$current_month.'-28';  
        }
        else
        {
             $to_date = $current_year.'-'.$current_month.'-30';
        }


        $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
        ->bindValue(':params_1',$from_date)
        ->bindValue(':params_2',$to_date)
        ->queryAll();
        if($model->load(Yii::$app->request->get())){
            if($model->from_date=='')
            {
                $model->from_date = date('Y-m', strtotime('0 month'));
            }
            if($model->to_date == '')
            {
                $model->to_date = $model->from_date;
            }
            $from_date = $model->from_date. '-01';
                if(date("F",strtotime($model->to_date))== 'February')
                {
                    if((date("Y",strtotime($model->to_date))/4) == 0)
                      $to_date = $model->to_date. '-29';
                    else
                      $to_date = $model->to_date. '-28';  
                }
                else
                {
                     $to_date = $model->to_date. '-30';
                }
            // $to_date = $model->to_date. '-30';
            $query = Yii::$app->db->createCommand("CALL gstr_1(:params_1,:params_2)")
            ->bindValue(':params_1',$from_date)
            ->bindValue(':params_2',$to_date)
            ->queryAll();
        }
        $dataProvider = new ArrayDataProvider([
            'allModels'=>$query,
            'pagination' => false,
        ]);

        if($print == true)
        {

            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/gstr1-details/gstr1print', [
                'dataProvider' => $dataProvider,
                'from_date' => $from_date,
                'to_date'=>$to_date,
                'model' =>$model,

            ]));
            $mpdf->Output('Gstr1-Report.pdf', 'I');
            // $this->actionExportprint($dataProvider,$from_date,$to_date);
        }

        if($excel==true)
        {
            // print_r($to_date);
            // die();
           $this->actionExcelreport($from_date,$to_date,$model); 
        }

        return $this->render('index', [
            'model' => $model,
            'dataProvider' => $dataProvider,
            'from' => $from_date,
            'to' => $to_date,
        ]);
    }

    public function actionGstr1details($from_date=null,$to_date=null,$from=null,$print=null)
    {
        $model = new Gstr1Details();
        // print_r($from);
        // die();
            if($from == '4 - Taxable outward supplies made to registered person')
            {
                $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                          ->andWhere(['!=','gstn_no','']);
            }
            else if($from == '5 - Taxable outward supplies to a consumer of Inter-State Supplies and Invoice Value > 2.5 Lakhs') 
            {
                $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                          ->andWhere(['!=','point_of_supply',21])
                                          ->andWhere(['>','total_value',250000]);
            }
            else if($from == '7 - Taxable outward supplies to a consumer other than (5)') 
            {
                $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                          ->andWhere(['=','gstn_no','']);
                          
            }
            else if($from == 'credit_notes')
            {
                $query = Gstr1Creditnotes::find()->where(['between','creditnote_date',$from_date,$to_date])
                                          ->andWhere(['!=','gstn_no','']);
            }

             if($model->load(Yii::$app->request->get())){

                if($model->from_date=='')
                {
                    $model->from_date = date('Y-m', strtotime('0 month'));
                }
                if($model->to_date == '')
                {
                    $model->to_date = $model->from_date;
                }


                $from_date = $model->from_date. '-01';

                if(date("F",strtotime($model->to_date))== 'February')
                {
                    if((date("Y",strtotime($model->to_date))/4) == 0)
                      $to_date = $model->to_date. '-29';
                    else
                      $to_date = $model->to_date. '-28';  
                }
                else
                {
                     $to_date = $model->to_date. '-30';
                }
                // $to_date = $model->to_date. '-30';

                if($from == '4 - Taxable outward supplies made to registered person')
                {
                    $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                              ->andWhere(['!=','gstn_no','']);
                }
                else if($from == '5 - Taxable outward supplies to a consumer of Inter-State Supplies and Invoice Value > 2.5 Lakhs') 
                {
                    $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                              ->andWhere(['!=','point_of_supply',21])
                                              ->andWhere(['>','total_value',250000]);
                }
                else if($from == '7 - Taxable outward supplies to a consumer other than (5)') 
                {
                    $query = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])
                                              ->andWhere(['=','gstn_no','']);
                              
                }
                else if($from == 'credit_notes')
                {
                    $query = Gstr1Creditnotes::find()->where(['between','creditnote_date',$from_date,$to_date])
                                              ->andWhere(['!=','gstn_no','']);
                }

             }

            $dataProvider = new ActiveDataProvider([
              'query'=>$query,
              'pagination' => false,
            ]);


            if($print==true)
            {
                // print('dd');
                // die();
                if($from=='4 - Taxable outward supplies made to registered person' || $from=='5 - Taxable outward supplies to a consumer of Inter-State Supplies and Invoice Value > 2.5 Lakhs')
                {
                        $dataProvider->pagination = false;
                        $mpdf = new mPDF;
                        $mpdf->showImageErrors = true;
                        $mpdf->WriteHTML($this->renderPartial('/gstr1-details/gstr1four', [
                            'dataProvider' => $dataProvider,
                            'from_date' => $from_date,
                            'to_date'=>$to_date,
                            'model' =>$model,
                            'from' => $from,
                        ]));
                        $mpdf->Output('Gstr1.pdf', 'I');
                }
                else if($from=='7 - Taxable outward supplies to a consumer other than (5)')
                {
                    $dataProvider->pagination = false;
                        $mpdf = new mPDF;
                        $mpdf->showImageErrors = true;
                        $mpdf->WriteHTML($this->renderPartial('/gstr1-details/gstr1four', [
                            'dataProvider' => $dataProvider,
                            'from_date' => $from_date,
                            'to_date'=>$to_date,
                            'model' =>$model,
                            'from' => $from,
                        ]));
                        $mpdf->Output('Gstr1.pdf', 'I');
                }
                else
                {
                    $dataProvider->pagination = false;
                        $mpdf = new mPDF;
                        $mpdf->showImageErrors = true;
                        $mpdf->WriteHTML($this->renderPartial('/gstr1-details/gstr1four', [
                            'dataProvider' => $dataProvider,
                            'from_date' => $from_date,
                            'to_date'=>$to_date,
                            'model' =>$model,
                            'from' => $from,
                        ]));
                        $mpdf->Output('Gstr1.pdf', 'I');
                }
               
            }


            return $this->render('gstr1details', [
              'model' => $model,
              'from' => $from,
              'to_date'=>$to_date,
              'from_date'=>$from_date,
              'dataProvider' => $dataProvider,
            ]);



    }

  public function actionExcelreport($from_date=null,$to_date=null,$model=null)
  {
     $phpExcel = new \PHPExcel;
        $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      $inv_details = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])->all();
      // print_r($inv_details);
      // die();
      
      // Making headers text bold and larger
      $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A2:V2')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A4:V4')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A3:V3')->getFont()->setBold(true)->setSize(12);
      // $sheet->getColumnDimension('A:Y')->setWidth(30);
      
      $sheet->mergeCells('A1:S1');
      $sheet->mergeCells('A2:S2');
      // $sheet->mergeCells('A3:S3');

      $sheet->getColumnDimension('A')->setWidth(30);
      $sheet->getColumnDimension('B')->setWidth(50);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);
      $sheet->getColumnDimension('E')->setWidth(20);
      $sheet->getColumnDimension('F')->setWidth(20);
      $sheet->getColumnDimension('G')->setWidth(20);
      $sheet->getColumnDimension('H')->setWidth(20);
      $sheet->getColumnDimension('I')->setWidth(20);
      $sheet->getColumnDimension('J')->setWidth(20);
      $sheet->getColumnDimension('K')->setWidth(20);
      $sheet->getColumnDimension('L')->setWidth(20);
      $sheet->getColumnDimension('M')->setWidth(20);
      $sheet->getColumnDimension('N')->setWidth(20);
      $sheet->getColumnDimension('O')->setWidth(20);
      $sheet->getColumnDimension('P')->setWidth(20);
      $sheet->getColumnDimension('Q')->setWidth(20);
      $sheet->getColumnDimension('R')->setWidth(20);
      $sheet->getColumnDimension('S')->setWidth(20);
      $sheet->getColumnDimension('T')->setWidth(20);
      $sheet->getColumnDimension('U')->setWidth(20);
      $sheet->getColumnDimension('V')->setWidth(20);
      $sheet->getColumnDimension('W')->setWidth(20);
      $sheet->getColumnDimension('X')->setWidth(20);
      $sheet->getColumnDimension('Y')->setWidth(20);

      $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED - GSTIN/UIN:21AAPCM1333E1ZX');
      $sheet ->getCell('A2')->setValue('GST Sales Register');
      if($from_date!='' && $to_date != '')
      {
         $sheet ->getCell('A3')->setValue(date('d-m-Y', strtotime($from_date)).' to '.date('d-m-Y', strtotime($to_date)));
      }
      

      // $sheet ->getCell('A3')->setValue('Invoice Details');

      $sheet->setCellValue('A4',  'Bill No');
      $sheet->setCellValue('B4',  'Bill Date');
      $sheet->setCellValue('C4',  'Customer Name');
      $sheet->setCellValue('D4',  'GST TIN No');
      $sheet->setCellValue('E4',  'State');
      $sheet->setCellValue('F4',  'Invoice Type');
      $sheet->setCellValue('G4',  'Sales Ledger');
      $sheet->setCellValue('H4',  'Product');
      $sheet->setCellValue('I4',  'HSN');
      $sheet->setCellValue('J4',  'UOM');
      $sheet->setCellValue('K4',  'Qty');
      $sheet->setCellValue('L4',  'Price');
      $sheet->setCellValue('M4',  'Rate');
      $sheet->setCellValue('N4',  'Discount');
      $sheet->setCellValue('O4',  'Sub Total');
      $sheet->setCellValue('P4',  'CGST Amount');
      $sheet->setCellValue('Q4',  'SGST Amount');
      $sheet->setCellValue('R4',  'IGST Amount');
      $sheet->setCellValue('S4',  'Gross Total');
      $sheet->setCellValue('T4',  'TCS Addition');
      $sheet->setCellValue('U4',  'Other Additions/Substractions');
      $sheet->setCellValue('V4',  'Invoice Amount');

      // $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
      $row = 5;
        foreach ($inv_details as $data) {

            $invoice = Invoice::find()->where(['invoice_id'=>$data->invoice_id])->one();
            $invoiceproduct = InvoiceProduct::find()->where(['invoice_id'=>$invoice->id])->all();
            $customer = Customer::find()->where(['id'=>$invoice->customer_name])->one();
            

            foreach ($invoiceproduct as $pdt) {

                $product = Product::find()->where(['id'=>$pdt->product_id])->one();

                $sheet->setCellValue('A' . $row,  $data->invoice_id);
                $sheet->setCellValue('B' . $row,  date('d-m-Y', strtotime($data->invoice_date)));
                $sheet->setCellValue('C' . $row,  $customer->business_name);    
                $sheet->setCellValue('D' . $row,  (string)$data->gstn_no); 
                $sheet->setCellValue('E' . $row,  (string)$data->point_of_supply); 
                $sheet->setCellValue('F' . $row,  '');
                $sheet->setCellValue('G' . $row,  'Sales - Taxable');
                $sheet->setCellValue('H' . $row,  $product->product_name);
                $sheet->setCellValue('I' . $row,  (string)$product->hsn_sac_code);
                $sheet->setCellValue('J' . $row,  $pdt->units);
                $sheet->setCellValue('K' . $row,  $pdt->quantity);
                $sheet->setCellValue('L' . $row,  $pdt->unit_price);
                $sheet->setCellValue('M' . $row,  $pdt->price);
                $sheet->setCellValue('N' . $row,  $pdt->discount);
                $sheet->setCellValue('O' . $row,  $data->taxable_value);
                $sheet->setCellValue('P' . $row,  $data->cgst_value);
                $sheet->setCellValue('Q' . $row,  $data->sgst_amount);
                $sheet->setCellValue('R' . $row,  $data->igst_value);
                $sheet->setCellValue('S' . $row,  (string)($data->taxable_value+$data->cgst_value+$data->sgst_amount+$data->igst_value));
                $sheet->setCellValue('T' . $row,  $invoice->tcs_amount);
                $sheet->setCellValue('U' . $row,  $invoice->round_off_amount);
                $sheet->setCellValue('V' . $row,  $data->total_value);

                $row ++;

            }

        }

        


       ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="GSTR1-Report.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
  }



  public function actionGstr3Outward($excel=null,$from_date=null,$to_date=null)
  {

    $session = Yii::$app->session;
    $model = new Gstr1Details;
    // $credit_model = new Gstr1Creditnotes;

    $all_inv = Gstr1Details::find()->all();
    $inv_numbers = [];
    $i =0;
    foreach ($all_inv as $data)
    {
        $inv_details = Invoice::find()->where(['invoice_id'=>$data->invoice_id])->one();
        $inv_numbers[$i] = $inv_details->id;
        $i++;
    }

    if (isset($from_date) && isset($to_date)) {

       

        $from_month = date("m",strtotime($from_date));
        $from_year = date("Y",strtotime($from_date));

        $to_month = date("m",strtotime($to_date));
        $to_year = date("Y",strtotime($to_date));

         
        $from_date = $from_year.'-'.$from_month. '-01';

        if(date("F",strtotime($to_date))== 'February')
            {
                if((date("Y",strtotime($model->to_date))/4) == 0)
                  $to_date = $to_year.'-'.$to_month. '-29';
                else
                  $to_date = $to_year.'-'.$to_month. '-28';  
            }
	     else if (date("F",strtotime($to_date))== 'January' || date("F",strtotime($to_date))== 'March' || date("F",strtotime($to_date))== 'May' || date("F",strtotime($to_date))== 'July' || date("F",strtotime($to_date))== 'August' || date("F",strtotime($to_date))== 'October' || date("F",strtotime($to_date))== 'December' ) {
                $to_date = $to_year.'-'.$to_month. '-31';
            }
            else
            {
                 $to_date = $to_year.'-'.$to_month. '-30';
            }
        
        $session->set('prv_from_date',$from_date);
        $session->set('prv_to_date',$to_date);


    }


    $prv_from_date = $session->get('prv_from_date');
    $prv_to_date = $session->get('prv_to_date');
  

    if($from_date!=null && $to_date!=null)
    {
        
            $from_month = date("m",strtotime($from_date));
            $from_year = date("Y",strtotime($from_date));

            $to_month = date("m",strtotime($to_date));
            $to_year = date("Y",strtotime($to_date));

             
            $from_date = $from_year.'-'.$from_month. '-01';

            if(date("F",strtotime($to_date))== 'February')
                {
                    if((date("Y",strtotime($model->to_date))/4) == 0)
                      $to_date = $to_year.'-'.$to_month. '-29';
                    else
                      $to_date = $to_year.'-'.$to_month. '-28';  
                }
	         else if (date("F",strtotime($to_date))== 'January' || date("F",strtotime($to_date))== 'March' || date("F",strtotime($to_date))== 'May' || date("F",strtotime($to_date))== 'July' || date("F",strtotime($to_date))== 'August' || date("F",strtotime($to_date))== 'October' || date("F",strtotime($to_date))== 'December' ) {
                $to_date = $to_year.'-'.$to_month. '-31';
            }
                else
                {
                     $to_date = $to_year.'-'.$to_month. '-30';
                }

                $query = Gstr3Outward::find()->where(['between', 'date', $from_date,$to_date]);
    }
    else
    {
        $query = Gstr3Outward::find(); 
    }
   
    if($model->load(Yii::$app->request->get())){

        $from_date=null;
        $to_date=null;
        $query = Gstr3Outward::find();

        $query->andFilterWhere(['like','receiver_gstn',$model->gst_number])
              ->andFilterWhere(['like', 'hsn_sac_code', $model->hsn_no])
              ->andFilterWhere(['like', 'sales_type', $model->bill_type])
              ->andFilterWhere(['like', 'supply_type', $model->supply_type])
              ->andFilterWhere(['like', 'supply_reverse_change', $model->reverse_change])
              ->andFilterWhere(['like', 'product_id', $model->find_product])
              ->andFilterWhere(['like', 'settings_id', $model->setting_type])
              ->andFilterWhere(['like', 'city',$model->location]); 

              if($model->customer_type=='vendor')
              {
                // print_r('dd');
                // die();
                if($model->find_customer!='')
                {
                    $query->andFilterWhere(['like', 'customer_name', $model->find_customer])
                      ->andFilterWhere(['like', 'party_type', 'vendor']);
                }
                
              }
              else if($model->customer_type=='customer')
              {
                if($model->find_customer!='')
                {
                    $query->andFilterWhere(['like', 'customer_name', $model->find_customer])
                      ->andFilterWhere(['like', 'party_type', 'customer']);
                }
                
              }
              if($model->time_frame){
                if($model->time_frame=='Today'){
                    
                $query->andFilterWhere(['like', 'date', date('Y-m-d')]);
                }elseif($model->time_frame=='Current Week') {
                    $query->andFilterWhere(['>=', 'date',date('Y-m-d',strtotime('last monday')) ]);
                }elseif($model->time_frame=='Current Month') {
                    // print_r(date ('Y-m-d', strtotime ('first day of this month')));
                    // die();
                    $query->andFilterWhere(['>=', 'date',date ('Y-m-d', strtotime ('first day of this month')) ]);
                }
                elseif($model->time_frame=='Current Year') {
                    $query->andFilterWhere(['>=', 'date',date('Y-m-d',strtotime(date('Y-04-01')))]);
                }elseif($model->time_frame=='Custom'){

                    $query->andFilterWhere(['between', 'date', $model->from,$model->to]);
                } 
            } 

    }

     $dataProvider = new ActiveDataProvider([
            'query'=>$query,
        ]);

     // print_r($dataProvider->models);
     // die();

     if($excel == true)
    {
        // print_r('dd');
        // die();
        $this->actionGstrexcelreport($dataProvider);
    }
    return $this->render('/gst-report/gstr3-outward', [
        'model' => $model,  
        'dataProvider' => $dataProvider,
        'from_date' => $from_date,
        'to_date' => $to_date,
        'prv_from_date' => $prv_from_date,
        'prv_to_date' => $prv_to_date, 
        // 'dataProvider2' => $dataProvider2,       
    ]);
  }


  public function actionHsndetails($string=null)
  {
       if($string!=null)
        $data =  HSNCode::find()->where(['like','description',$string])->limit(10)->asArray()->all();
        else
        $data =  HSNCode::find()->limit(10)->asArray()->all();

        $productlist=ArrayHelper::map($data, 'code', 'description');
        
        return json_encode($data);
  }

  public function actionProductdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Product::find()->limit(10)->all();
        else
            $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }

    public function actionCustomerdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Customer::find()->limit(10)->all();
        else
            $product=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'business_name');
        return json_encode($productlist);
    }


    public function actionVendordetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Vendor::find()->limit(10)->all();
        else
        $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }


    public function actionGstrexcelreport($dataProvider=null)
  {
    // print_r($dataProvider->models);
    // die();

    // $dataProvider = new ActiveDataProvider([
    //         'query'=>$query,
    //     ]);
     $phpExcel = new \PHPExcel;
        $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      // $inv_details = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])->all();
      // print_r($inv_details);
      // die();
      
      // Making headers text bold and larger
      $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A2:V2')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A4:V4')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A3:V3')->getFont()->setBold(true)->setSize(12);
      // $sheet->getColumnDimension('A:Y')->setWidth(30);
      
      $sheet->mergeCells('A1:S1');
      $sheet->mergeCells('A2:S2');
      // $sheet->mergeCells('A3:S3');

      $sheet->getColumnDimension('A')->setWidth(30);
      $sheet->getColumnDimension('B')->setWidth(50);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);
      $sheet->getColumnDimension('E')->setWidth(20);
      $sheet->getColumnDimension('F')->setWidth(20);
      $sheet->getColumnDimension('G')->setWidth(20);
      $sheet->getColumnDimension('H')->setWidth(20);
      $sheet->getColumnDimension('I')->setWidth(20);
      $sheet->getColumnDimension('J')->setWidth(20);
      $sheet->getColumnDimension('K')->setWidth(20);
      $sheet->getColumnDimension('L')->setWidth(20);
      $sheet->getColumnDimension('M')->setWidth(20);
      $sheet->getColumnDimension('N')->setWidth(20);
      $sheet->getColumnDimension('O')->setWidth(20);
      $sheet->getColumnDimension('P')->setWidth(20);
      $sheet->getColumnDimension('Q')->setWidth(20);
      $sheet->getColumnDimension('R')->setWidth(20);
      $sheet->getColumnDimension('S')->setWidth(20);
      $sheet->getColumnDimension('T')->setWidth(20);
      $sheet->getColumnDimension('U')->setWidth(20);
      $sheet->getColumnDimension('V')->setWidth(20);
      $sheet->getColumnDimension('W')->setWidth(20);
      $sheet->getColumnDimension('X')->setWidth(20);
      $sheet->getColumnDimension('Y')->setWidth(20);

      $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
      $sheet ->getCell('A2')->setValue('F2G/30, INDRADHANU MARKETIRC VILLAGE,');
      // if($from_date!='' && $to_date != '')
      // {
      //    $sheet ->getCell('A3')->setValue(date('d-m-Y', strtotime($from_date)).' to '.date('d-m-Y', strtotime($to_date)));
      // }
      

      // $sheet ->getCell('A3')->setValue('Invoice Details');

      $sheet->setCellValue('A4',  'Date');
      $sheet->setCellValue('B4',  'Particulars');
      $sheet->setCellValue('C4',  'Vch No');
      $sheet->setCellValue('D4',  'Receiver GST No');
      $sheet->setCellValue('E4',  'Product');
      $sheet->setCellValue('F4',  'HSN/SAC Code');
      $sheet->setCellValue('G4',  'Qty');
      $sheet->setCellValue('H4',  'Rate');
      $sheet->setCellValue('I4',  'Discount');
      $sheet->setCellValue('J4',  'Taxable Value');
      $sheet->setCellValue('K4',  'IGST');
      $sheet->setCellValue('L4',  'CGST');
      $sheet->setCellValue('M4',  'SGST');
      $sheet->setCellValue('N4',  'CESS');
     

      // $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
      $row = 5;

     $quantity = 0;
     $taxable = 0;
     $total_igst = 0;
     $total_sgst = 0;
     $total_cgst = 0;
     $total_cess = 0.00;


        foreach ($dataProvider->models as $data) {

                if($data->quantity != '')
                {
                    $quantity = $quantity + $data->quantity;
                }
                if($data->discount_type=='%')
                {
                    $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                    $taxable = $taxable + (($data->unit_price*$data->quantity)-$discount_value);
                }
                else
                {
                    $taxable = $taxable + (($data->unit_price-$data->discount)*$data->quantity);
                }
                if($data->igst_amount!='' && $data->igst_amount!='0.00')
                {
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount =$data->amount-(($data->unit_price*$data->quantity)-$discount_value);
                        $total_igst = $total_igst + $finalamount;
                    }
                    else
                    {
                        $finalamount = $data->amount-(($data->unit_price-$data->discount)*$data->quantity);
                        $total_igst = $total_igst + $finalamount; 
                    }  
                }
                if($data->cgst_amount!='' && $data->cgst_amount!='0.00' )
                {
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount = $data->amount-(($data->unit_price*$data->quantity)-$discount_value);
                        $total_cgst = $total_cgst + ($finalamount/2);
                    }
                    else
                    {
                        $finalamount = $data->amount-(($data->unit_price-$data->discount)*$data->quantity);
                        $total_cgst = $total_cgst + ($finalamount/2);
                    }
                }

                if($data->sgst_amount!='' && $data->sgst_amount!='0.00')
                {
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount = $data->amount-(($data->unit_price*$data->quantity)-$discount_value);
                        $total_sgst = $total_sgst + ($finalamount/2);
                    }
                    else
                    {
                        $finalamount = $data->amount-(($data->unit_price-$data->discount)*$data->quantity);
                        $total_sgst = $total_sgst + ($finalamount/2);
                    }
                }

                $total_igst = number_format((float)$total_igst, 2, '.', '');
                $total_sgst = number_format((float)$total_sgst, 2, '.', '');
                $total_cgst = number_format((float)$total_cgst, 2, '.', '');
                $taxable = number_format((float)$taxable, 2, '.', '');
                $total_cess = number_format((float)$total_cess, 2, '.', '');

                $sheet->getStyle('I' . ($row))->getNumberFormat()->setFormatCode('0.00');
                $sheet->getStyle('J' . ($row))->getNumberFormat()->setFormatCode('0.00');
                $sheet->getStyle('K' . ($row))->getNumberFormat()->setFormatCode('0.00');
                $sheet->getStyle('L' . ($row))->getNumberFormat()->setFormatCode('0.00');
                $sheet->getStyle('M' . ($row))->getNumberFormat()->setFormatCode('0.00');
                $sheet->getStyle('N' . ($row))->getNumberFormat()->setFormatCode('0.00');

            $sheet->getStyle('I' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);    
            $sheet->getStyle('J' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('K' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('L' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('M' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('N' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);

           // $invoice = Invoice::find()->where(['invoice_id'=>$data->invoice_id])->one();
            // $invoiceproduct = InvoiceProduct::find()->where(['invoice_id'=>$invoice->id])->all();
            // $customer = Customer::find()->where(['id'=>$invoice->customer_name])->one();
            

            // foreach ($invoiceproduct as $pdt) {

                // $product = Product::find()->where(['id'=>$pdt->product_id])->one();

                $sheet->setCellValue('A' . $row,  date('d-m-Y', strtotime($data['date'])));
                if($data['data_from']=='Invoice')
                {
                    $customer = Customer::find()->where(['id'=>$data->customer_name])->one();
                    $sheet->setCellValue('B' . $row,  $customer->business_name);
                }
                else
                {
                    if($data['party_type']=='vendor')
                    {
                        $customer = Vendor::find()->where(['id'=>$data->customer_name])->one();
                        $sheet->setCellValue('B' . $row,  $customer->business_name);
                    }
                    else if($data['party_type']=='customer')
                    {
                        $customer = Customer::find()->where(['id'=>$data->customer_name])->one();
                        $sheet->setCellValue('B' . $row,  $customer->business_name);
                    }
                      
                }

                $sheet->setCellValue('C' . $row,  $data['inv_id']);    
                $sheet->setCellValue('D' . $row,  (string)$data['receiver_gstn']); 
                $sheet->setCellValue('E' . $row,  (string)$data['product_name']); 
                $sheet->setCellValue('F' . $row,  $data['hsn_sac_code']);
                $sheet->setCellValue('G' . $row,  $data['quantity']);
                $sheet->setCellValue('H' . $row,  $data['unit_price'].'/'.$data['units']);

                if($data['discount_type']=='%')
                {
                   $discount_value = ($data['unit_price']*$data['quantity'])*(($data['discount'])/100);
                   $sheet->setCellValue('I' . $row,  $discount_value);
                }
                else
                {
                    $sheet->setCellValue('I' . $row,  $data['discount']);
                }

                if($data['discount_type']=='%')
                {
                    $discount_value = ($data['unit_price']*$data['quantity'])*(($data['discount'])/100);
                    $sheet->setCellValue('J' . $row,  (($data['unit_price']*$data['quantity'])-$discount_value));
                }
                else
                {
                    $sheet->setCellValue('J' . $row,  (($data['unit_price']-$data['discount'])*$data['quantity']));
                }

                //FOR IGST

                if($data->igst_amount!='' && $data->igst_amount!='0.00')
                {  
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount = number_format((float)($data->amount-(($data->unit_price*$data->quantity)-$discount_value)), 2, '.', '');
                         $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                        $sheet->setCellValue('K' . $row,  $num);
                    }
                    else
                    {
                        $finalamount = number_format((float)($data->amount-(($data->unit_price-$data->discount)*$data->quantity)), 2, '.', '');
                         $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                        $sheet->setCellValue('K' . $row,  $num);  
                    }
                }
                else
                {
                    $sheet->setCellValue('K' . $row,  '0.00');
                }

                //FOR CGST    
                if($data->cgst_amount!='' && $data->cgst_amount!='0.00' )
                {  
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount = number_format((float)(($data->amount-(($data->unit_price*$data->quantity)-$discount_value))/2), 2, '.', '');
                        $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                        $sheet->setCellValue('L' . $row,  $num);
                    }
                    else
                    {
                        $finalamount = number_format((float)(($data->amount-(($data->unit_price-$data->discount)*$data->quantity))/2), 2, '.', '');
                         $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                        $sheet->setCellValue('L' . $row,  $num);  
                    }
                }
                else
                {
                    $sheet->setCellValue('L' . $row,  '0.00');
                }

                //FOR SGST
                if($data->sgst_amount!='' && $data->sgst_amount!='0.00')
                {  
                    if($data->discount_type=='%')
                    {
                        $discount_value = ($data->unit_price*$data->quantity)*(($data->discount)/100);
                        $finalamount = number_format((float)(($data->amount-(($data->unit_price*$data->quantity)-$discount_value))/2), 2, '.', '');
                             $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                             $sheet->setCellValue('M' . $row,  $num);
                    }
                    else
                    {
                        $finalamount = number_format((float)(($data->amount-(($data->unit_price-$data->discount)*$data->quantity))/2), 2, '.', '');
                         $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                        $sheet->setCellValue('M' . $row,  $num);   
                    }
                }
                else
                {
                    $sheet->setCellValue('M' . $row,  '0.00');
                }
 
                
                $sheet->setCellValue('N' . $row,  '0.00');

                $row ++;

            // }

        }
            $sheet->getStyle('A' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('G' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('J' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('K' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('L' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('M' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('N' . ($row))->getFont()->setBold(true)->setSize(12);

            $sheet->getStyle('I' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('J' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('K' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('L' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('M' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('N' . ($row))->getNumberFormat()->setFormatCode('0.00');

            $sheet->getStyle('J' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('K' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('L' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('M' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('N' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);

                $sheet->setCellValue('A' . $row,  'Grand Total');
                $sheet->setCellValue('G' . $row,  $quantity);
                $sheet->setCellValue('J' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($taxable)));
                $sheet->setCellValue('K' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($total_igst))); 
                $sheet->setCellValue('L' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($total_cgst)));
                $sheet->setCellValue('M' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$total_sgst));
                $sheet->setCellValue('N' . $row,  '0.00');

        


       ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="GSTR3-Outward-Report.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
  }




}
