<?php

namespace backend\modules\reports\controllers;

use backend\modules\reports\models\OverdueInvoiceReport;
use backend\modules\master\models\Customer;
use yii\data\ActiveDataProvider;
use yii\helpers\ArrayHelper;
use Mpdf\Mpdf;
use Yii;



class OverdueInvoiceReportController extends \yii\web\Controller
{
    public function actionIndex()
    {
        $model = new OverdueInvoiceReport();
        $query = OverdueInvoiceReport::find();

        if(Yii::$app->request->get()){
            $model->load(Yii::$app->request->queryParams);
            $query->andFilterWhere(['between','date', $model->from_date,$model->to_date])
                  ->andFilterWhere(['like','customer_name',$model->c_name])
                  ->andFilterWhere(['like','customer_type',$model->c_type])
                  ->andFilterWhere(['created_by'=>(string)$model->creator])
                  ->andFilterWhere(['executive'=>$model->exe]);

               if($model->order == 'casc'){
                    $query->orderBy(['customer_name'=>SORT_ASC]);
               }else if($model->order == 'cdsc')
                {
                   $query->orderBy(['customer_name'=>SORT_DESC]);
               }else if($model->order == 'ddasc')
               {
                  $query->orderBy(['due_days'=>SORT_ASC]);
                }else if($model->order == 'dddsc'){
                $query->orderBy(['due_days'=>SORT_DESC]);

               }

        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,

        ]);
        if($model->load(Yii::$app->request->post())){
            if (Yii::$app->request->post('print')==='export_print') {
                $mpdf = new mPDF;
                $mpdf->showImageErrors = true;
                $mpdf->WriteHTML($this->renderPartial('/overdue-invoice-report/export-print.php', [
                    'dataProvider' => $dataProvider,
                    'is_customer'=>$model->is_customer,
                    'is_invoiceid'=>$model->is_invoiceid,
                    'is_mobile'=>$model->is_mobile,
                    'is_phone'=>$model->is_phone,
                    'is_date'=>$model->is_date,
                    'is_amt'=>$model->is_amt,
                    'is_paidamt'=>$model->is_paidamt,
                    'is_unpaidamt'=>$model->is_unpaidamt,
                    'is_duedate'=>$model->is_duedate,
                    'is_days'=>$model->is_days,
                    'is_executives'=>$model->is_executives,
                    'is_notes'=>$model->is_notes,
                    'is_terms'=>$model->is_terms,
                    'is_currentoutstanding'=>$model->is_currentoutstanding,
                    'is_overdue'=>$model->is_overdue,
                    'is_totaloutstanding'=>$model->is_totaloutstanding,    
                ]));
                $mpdf->Output('Overdue-Invoice.pdf', 'I');
            }
            else {
                $i=65;
                $rowcount=7;
                $phpExcel = new \PHPExcel;
                $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
                $phpExcel->getActiveSheet()->getStyle('D1')->getAlignment()->setWrapText(true);
                // $phpExcel->getDefaultStyle()->getFont()->setSize(14);
                // $phpExcel ->getProperties()->setTitle("Vendor list");
                $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
                $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
                $sheet = $phpExcel ->getActiveSheet();

                // $sheet->setTitle('My product list');
                $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
                $sheet ->getCell('A2')->setValue('');
                $sheet ->getCell('A3')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
                $sheet ->getCell('A4')->setValue('BHUBANESWAR, Odisha');
                $sheet ->getCell('A5')->setValue('');
                $sheet ->getCell('A6')->setValue('Statement Of Account');

                $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
                $sheet->getStyle('A2:S2')->getFont()->setSize(11);
                $sheet->getStyle('A3:S3')->getFont()->setSize(11);
                $sheet->getStyle('A4:S4')->getFont()->setSize(11);
                $sheet->getStyle('A5:S5')->getFont()->setSize(11);
                $sheet->getStyle('A6:S6')->getFont()->setBold(true)->setSize(11);
                
                $sheet->getColumnDimension('A')->setWidth(40);
                $sheet->getColumnDimension('B')->setWidth(30);
                $sheet->getColumnDimension('C')->setWidth(20);
                $sheet->getColumnDimension('D')->setWidth(20);

                
                $sheet->mergeCells('A1:Q1');
                $sheet->mergeCells('A2:Q2');
                $sheet->mergeCells('A3:Q3');
                $sheet->mergeCells('A4:Q4');
                $sheet->mergeCells('A5:Q5');
                $sheet->mergeCells('A6:Q6');
                if($model->is_customer){
                $sheet->setCellValue(chr($i).$rowcount,  'Customer');
                $i++;
                }
                if($model->is_mobile){
                $sheet->setCellValue(chr($i).$rowcount,  'Mobile No');
                $i++;
                }
                if($model->is_phone){
                    $sheet->setCellValue(chr($i).$rowcount,  'Phone No.');
                    $i++;
                }
                if($model->is_invoiceid){
                   $sheet->setCellValue(chr($i).$rowcount,  'Invoice No.');
                   $i++;
                }
                if($model->is_date){
                    $sheet->setCellValue(chr($i).$rowcount,  'Date');
                    $i++;
                 }
                 if($model->is_amt){
                    $sheet->setCellValue(chr($i).$rowcount,  'Amount');
                    $i++;
                 }
                 if($model->is_paidamt){
                    $sheet->setCellValue(chr($i).$rowcount,  'Paid');
                    $i++;
                 }
                 if($model->is_unpaidamt){
                    $sheet->setCellValue(chr($i).$rowcount,  'Pending');
                    $i++;
                 }
                 if($model->is_duedate){
                    $sheet->setCellValue(chr($i).$rowcount,  'Due Date');
                    $i++;
                 }
                 if($model->is_days){
                    $sheet->setCellValue(chr($i).$rowcount,  'Days Crossed');
                    $i++;
                 }
                 if($model->is_executives){
                    $sheet->setCellValue(chr($i).$rowcount,  'Executive');
                    $i++;
                 }
                 if($model->is_notes){
                    $sheet->setCellValue(chr($i).$rowcount,  'Notes');
                    $i++;
                 }
                 if($model->is_terms){
                    $sheet->setCellValue(chr($i).$rowcount,  'Terms');
                    $i++;
                 }
                 if($model->is_currentoutstanding){
                    $sheet->setCellValue(chr($i).$rowcount,  'Current Outstanding');
                    $i++;
                 }
                 if($model->is_overdue){
                    $sheet->setCellValue(chr($i).$rowcount,  'Over Due');
                    $i++;
                 }
                 if($model->is_totaloutstanding){
                    $sheet->setCellValue(chr($i).$rowcount,  'Total Outstanding');
                    $i++;
                 }
                 $row=8;
                 $inv_amt=0;
                 $pending_amt=0;
                 $paid_amt=0;   
                 $amt_col;$paid_col;$pending_col;$curr_col;$outstanding_col;$overdue_col;              
                 foreach ($dataProvider->models as $data) {
                    $inv_amt+=$data->amount;
                    $pending_amt+=$data->pending;
                    $paid_amt+=$data->paid;
                    $i=65;
                    $customer=Customer::find()->where(['id'=>$data->customer_id])->one();
          
                    $sheet->getStyle('A'.$row)->getAlignment()->setWrapText(true);
                    // $sheet->getStyle('S'.$row)->getAlignment()->setWrapText(true);
                  
                    if($model->is_customer){
                        $sheet->getStyle(chr($i) . $row)->getAlignment()->setWrapText(true);
                        $sheet->setCellValue(chr($i) . $row, $customer->business_name);

                         $i++;
                        }
                        if($model->is_mobile){
                        $sheet->setCellValue(chr($i) . $row, $customer->mobile);
                        $i++;
                        }
                        if($model->is_phone){
                            $sheet->setCellValue(chr($i) . $row, $customer->phone);
                            $i++;
                        }
                        if($model->is_invoiceid){
                           $sheet->setCellValue(chr($i) . $row,$data->invoice_id);
                           $i++;
                        }
                        if($model->is_date){
                            $sheet->setCellValue(chr($i) . $row,  $data->date);
                            $i++;
                         }
                         if($model->is_amt){
                            $sheet->setCellValue(chr($i) . $row, $data->amount);
                            $amt_col=$i;
                            $i++;
                         }
                         if($model->is_paidamt){
                            $sheet->setCellValue(chr($i) . $row,  $data->paid);
                            $paid_col=$i;
                            $i++;
                         }
                         if($model->is_unpaidamt){
                            $sheet->setCellValue(chr($i) . $row,  $data->pending);
                            $pending_col=$i;
                            $i++;
                         }
                         if($model->is_duedate){
                            $sheet->setCellValue(chr($i) . $row,  $data->due_date);
                            $i++;
                         }
                         if($model->is_days){
                            $sheet->setCellValue(chr($i) . $row,$data->due_days_crossed);
                            $i++;
                         }
                         if($model->is_executives){
                            $sheet->setCellValue(chr($i) . $row,$data->executive);
                            $i++;
                         }
                         if($model->is_notes){
                            $sheet->setCellValue(chr($i) . $row, 'Notes');
                            $i++;
                         }
                         if($model->is_terms){
                            $sheet->setCellValue(chr($i) . $row, 'Terms');
                            $i++;
                         }
                         if($model->is_currentoutstanding){
                            $sheet->setCellValue(chr($i) . $row, '0.00');
                            $curr_col=$i;
                            $i++;
                         }
                         if($model->is_overdue){
                            $sheet->setCellValue(chr($i) . $row,$data->pending);
                            $overdue_col=$i;
                            $i++;
                         }
                         if($model->is_totaloutstanding){
                            $sheet->setCellValue(chr($i) . $row,$data->pending);
                            $outstanding_col=$i;
                            $i++;
                         }
            
                  $row++;   
                 } 
               //   print_r($paid_amt);die();
                 $sheet->setCellValue('A' . $row,'Total');
                 if($model->is_amt)
                 $sheet->setCellValue(chr($amt_col) . $row, (string)$inv_amt);
                 if($model->is_paidamt)
                 $sheet->setCellValue(chr($paid_col) . $row,(string)$paid_amt);
                 if($model->is_unpaidamt)
                 $sheet->setCellValue(chr($pending_col) . $row,(string)$pending_amt);
                 if($model->is_currentoutstanding)
                 $sheet->setCellValue(chr($curr_col) . $row,(string)$pending_amt);
                 if($model->is_overdue)
                 $sheet->setCellValue(chr($overdue_col) . $row,(string)$pending_amt);
                 if($model->is_totaloutstanding)
                 $sheet->setCellValue(chr($outstanding_col) . $row,(string)$pending_amt);


                ob_clean();
                ob_start();
     
                header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
                header('Content-Disposition: attachment; filename="OverdueInvoice.xls"'); // Write file to the browser 

                $writer->save('php://output');
                ob_flush();
                exit();
            }
                   
        }
        $dataProvider = new ActiveDataProvider([
            'query'=>$query,
        ]);
        return $this->render('index',[
            'model'=>$model,
            'dataProvider' => $dataProvider,
            ]);
    }
    public function actionCustomerdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Customer::find()->limit(10)->all();
        else
            $product=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'business_name', 'business_name');
        return json_encode($productlist);
    }
    public function actionExportPrint()
    {   
        // $dataProvider = new ActiveDataProvider([
        //     'query' => PurchaseVendorLedger::find()->orderBy(['Date' => SORT_DESC]),
        // ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/purchase-vendor-ledger/pdfexport', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('Purchase-vendor-ledger.pdf', 'D');
    }
}
