<?php

namespace backend\modules\reports\controllers;
use Yii;
use Mpdf\Mpdf;
use common\models\User;
use yii\helpers\ArrayHelper;
use yii\data\ArrayDataProvider;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\GroupName;
use backend\modules\reports\models\TrialBalance;

class ProfitLossController extends \yii\web\Controller
{
  public function actionIndex($print=null,$excel=null)
  {
    $model = new TrialBalance();
    $current_month = date("m");
    if($current_month >= 4){
    $from_year = date("Y");
    $from_date = $from_year. '-04-01';
    }
    else 
    {
       $from_year = date("Y") -1;
       $from_date = $from_year. '-04-01';
    }
    $to_date = date("Y-m-d");
    $query = Yii::$app->db->createCommand("CALL TrialBalance(:params_1,:params_2)")
    ->bindValue(':params_1',$from_date)
    ->bindValue(':params_2',$to_date)
    ->queryAll();

    if($model->load(Yii::$app->request->get())){
      $from_date = $model->from_date;
      $to_date = $model->to_date;
    $query = Yii::$app->db->createCommand("CALL TrialBalance(:params_1,:params_2)")
    ->bindValue(':params_1',$from_date)
    ->bindValue(':params_2',$to_date)
    ->queryAll();
   }

   $dataProvider = new ArrayDataProvider([ 
      'allModels'=>$query,
      'pagination' => false,
    ]);
   // $groups = Products::find()->select('other_columns,some_column')->distinct();
   if($print!=null)
    {
        $this->actionExportprint($dataProvider,$to_date,$from_date);
    }
    if($excel!='')
    {
      $this->actionExcelreport($dataProvider,$to_date);
    }
    // print_r($model->from_date);die();
    return $this->render('index', [
        'model' => $model,
        'dataProvider' => $dataProvider,
    ]);

  }

  public function actionExportprint($data=null,$date=null,$from_date=null)
  {
        $data->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/profit-loss/exportprint', [
            'dataProvider' => $data,
            'from_date' => $from_date,
            'to_date'=>$date,

        ]));
        $mpdf->Output('ProfitLoss.pdf', 'I');
  } 

  public function actionExcelreport($dataProvider=null,$excel=null)
  {
     $phpExcel = new \PHPExcel;
        $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      
      // Making headers text bold and larger
      $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
      


      $sheet->getColumnDimension('A')->setWidth(30);
      $sheet->getColumnDimension('B')->setWidth(50);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);
      $sheet->getColumnDimension('E')->setWidth(20);
 

      $sheet->setCellValue('A1',  'Group');
      $sheet->setCellValue('B1',  'Perticulars');
      $sheet->setCellValue('C1',  '');
 

      $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('B1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('C1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
       $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('B1')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('C1')->getFont()->setBold(true)->setSize(12);


        $row=3;
        $total_credit =0;
        $total_debit =0;
        $total_income =0;
        $total_expense = 0;
        $total = 0;
        $total_assets =0;
        $total_liabilities =0;
        $total_diff_in_asset_liability =0;

          foreach ($dataProvider->models as $data) {
            if($data['credit']!='' && $data['credit']!=NULL)
              $total_credit = $total_credit + $data['credit'];
            if($data['Debit']!='' && $data['Debit']!=NULL)
              $total_debit = $total_debit + $data['Debit'];

              $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
              

              if($data['group_name']=='income')
              {

                  if($data['credit']!='' && $data['credit']!=NULL)
                    $total_income = $total_income + $data['credit'];
                  

                   $sheet->setCellValue('A' . $row,  $data['group_name']);
                   $sheet->setCellValue('B' . $row,  $data['Particulars']);
                     
                   $sheet->setCellValue('C' . $row,   preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",  number_format((float)$data['credit'], 2, '.', '')));
                   $row++;
              }         
          }
        
          foreach ($dataProvider->models as $data) {

            $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
              $sheet->getStyle('D' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
           
              if($data['group_name']=='expense')
              {
                  
                  if($data['Debit']!='' && $data['Debit']!=NULL)
                    $total_expense = $total_expense + $data['Debit'];

                   $sheet->setCellValue('A' . $row,  $data['group_name']);
                   $sheet->setCellValue('B' . $row,  $data['Particulars']);
                   $sheet->setCellValue('C' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",  number_format((float)$data['Debit'], 2, '.', '')));    
                   $row++;
              } 
             
          }

       
          $total = $total_income - $total_expense;
          $all_total = $total_expense + $total_income;
          $row = $row +1;

          $sheet->getStyle('A' . ($row))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('B' . ($row))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('C' . ($row))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('C' . ($row+1))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('D' . ($row))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('E' . ($row))->getFont()->setBold(true)->setSize(12);
          $sheet->getStyle('C' . ($row))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
          $sheet->getStyle('D' . ($row))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
          $sheet->getStyle('C' . ($row+1))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT); 
          $sheet->getStyle('A' . ($row+1))->getFont()->setBold(true)->setSize(12); 
           

           $sheet->setCellValue('A' . ($row),  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 'Expense Total'));  
          $sheet->setCellValue('A' . ($row+1),  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 'Income Total'));  

          $sheet->setCellValue('C' . ($row),  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",  number_format((float)$total_expense, 2, '.', '')));  
          $sheet->setCellValue('C' . ($row+1),  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",  number_format((float)$total_income, 2, '.', '')));  


          if($total<0)
          {
            $sheet->getStyle('D'.$row)->getFont()->getColor()->setRGB('FF0000');
          }
          else
          {
            $sheet->getStyle('D'.$row)->getFont()->getColor()->setRGB('080707');
          }

          $sheet->setCellValue('D' . ($row),  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",  number_format((float)$total, 2, '.', ''))); 

     
        

        
       ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="ProfitLoss.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
  }

}
