<?php

namespace backend\modules\reports\controllers;

use backend\modules\master\models\Vendor;
use backend\modules\users\models\PurchaseBill;
use backend\modules\users\models\PurchasePayment;
use common\models\User;
use Mpdf\Mpdf;
use Yii;
use yii\helpers\ArrayHelper;
use backend\modules\reports\models\PurchaseOutstandingExpense;
use yii\data\ActiveDataProvider;

class PurchaseOutstandingExpenseController extends \yii\web\Controller
{
    public function actionIndex()
    {
    	$model = new PurchaseOutstandingExpense();
        $query = PurchaseOutstandingExpense::find();

        if($model->load(Yii::$app->request->get())){

            $query->andFilterWhere(['like', 'vendor_category', $model->vendor])
                   // ->andFilterWhere(['like', 'executive', $model->executive_name])
                   ->andFilterWhere(['between', 'date', $model->from_date,$model->to_date]);

            if($model->sort){

                if($model->sort=='name.asc'){
                 $query->orderBy(['vendor_category' => SORT_ASC]);
                } elseif($model->sort=='name.desc'){
                    $query->orderBy(['vendor_category' => SORT_DESC]);
                }elseif($model->sort=='duedays.asc'){
                    $query->orderBy(['due_date' => SORT_DESC]);
                }elseif($model->sort=='duedays.desc'){
                    $query->orderBy(['due_date' => SORT_ASC]);
                }
            } 
            if($model->setting){

                if($model->setting=='Tax Bill'){
                 $query->andFilterWhere(['!=', 'bill_id', 'null']);
                } 
                // else
                // {
                //     $query->andFilterWhere(['==', 'bill_id', ''])
                //         ->andFilterWhere(['==', 'bill_id', null]);
                // }
            } 
            if($model->due_days)
            {
                if($model->due_days=='7days')
                {
                    $lastdate = date("Y-m-d", strtotime("-7 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='10days')
                {
                    $lastdate = date("Y-m-d", strtotime("-10 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='15days')
                {
                    $lastdate = date("Y-m-d", strtotime("-15 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='30days')
                {
                    $lastdate = date("Y-m-d", strtotime("-30 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='45days')
                {
                    $lastdate = date("Y-m-d", strtotime("-45 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='60days')
                {
                    $lastdate = date("Y-m-d", strtotime("-60 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='75days')
                {
                    $lastdate = date("Y-m-d", strtotime("-75 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='90days')
                {
                    $lastdate = date("Y-m-d", strtotime("-90 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='120days')
                {
                    $lastdate = date("Y-m-d", strtotime("-120 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
                if($model->due_days=='120days>')
                {
                    $lastdate = date("Y-m-d", strtotime("-121 days"));
                    $query->andFilterWhere(['<', 'due_date', $lastdate]);
                }
            }       
            }    

        

        $dataProvider = new ActiveDataProvider([
            'query'=>$query,

        ]);


        if($model->load(Yii::$app->request->post())){
            if (Yii::$app->request->post('print')==='export_print') {
                $mpdf = new mPDF;
                $mpdf->showImageErrors = true;
                $dataProvider->pagination = false;
                $mpdf->WriteHTML($this->renderPartial('/purchase-outstanding-expense/pdfexport.php', [
                    'dataProvider' => $dataProvider,
                    'is_vendor'=>$model->is_vendor,
                    'vendor_mobile'=>$model->vendor_mobile,
                    'bill_date'=>$model->bill_date,
                    'bill_referance'=>$model->bill_referance,
                    'bill_amount'=>$model->bill_amount,
                    'bill_paid_amount'=>$model->bill_paid_amount,
                    'bill_unpaid_amount'=>$model->bill_unpaid_amount,
                    'bill_bue_date'=>$model->bill_bue_date,
                    'bill_days'=>$model->bill_days,
                    'bill_notes'=>$model->bill_notes,
                    'bill_terms'=>$model->bill_terms,
                    'bill_over_due'=>$model->bill_over_due,
                    'bill_current_outstanding'=>$model->bill_current_outstanding,
                    'bill_total_outstanding'=>$model->bill_total_outstanding,    
                ]));
                $mpdf->Output('Purchase_outstanding_expense.pdf', 'I');
            }
            else if (Yii::$app->request->post('pdf')==='export_pdf') {
                    $mpdf = new mPDF;
                    $mpdf->showImageErrors = true;
                    $dataProvider->pagination = false;
                    $mpdf->WriteHTML($this->renderPartial('/purchase-outstanding-expense/pdfexport.php', [
                        'dataProvider' => $dataProvider,
                        'is_vendor'=>$model->is_vendor,
                        'vendor_mobile'=>$model->vendor_mobile,
                        'bill_date'=>$model->bill_date,
                        'bill_referance'=>$model->bill_referance,
                        'bill_amount'=>$model->bill_amount,
                        'bill_paid_amount'=>$model->bill_paid_amount,
                        'bill_unpaid_amount'=>$model->bill_unpaid_amount,
                        'bill_bue_date'=>$model->bill_bue_date,
                        'bill_days'=>$model->bill_days,
                        'bill_notes'=>$model->bill_notes,
                        'bill_terms'=>$model->bill_terms,
                        'bill_over_due'=>$model->bill_over_due,
                        'bill_current_outstanding'=>$model->bill_current_outstanding,
                        'bill_total_outstanding'=>$model->bill_total_outstanding,    
                    ]));
                    $mpdf->Output('Purchase_outstanding_expense.pdf', 'D');
                # code...
            }
            else if(Yii::$app->request->post('excel')==='export_excel')
            {
                $i=65;
                $rowcount=7;
                $phpExcel = new \PHPExcel;
                $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
                $phpExcel->getActiveSheet()->getStyle('D1')->getAlignment()->setWrapText(true);
                // $phpExcel->getDefaultStyle()->getFont()->setSize(14);
                // $phpExcel ->getProperties()->setTitle("Vendor list");
                $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
                $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
                $sheet = $phpExcel ->getActiveSheet();

                // $sheet->setTitle('My product list');
                $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
                $sheet ->getCell('A2')->setValue('');
                $sheet ->getCell('A3')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
                $sheet ->getCell('A4')->setValue('BHUBANESWAR, Odisha');
                $sheet ->getCell('A5')->setValue('');
                $sheet ->getCell('A6')->setValue('Purchase Outstanding Expense');

                $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
                $sheet->getStyle('A2:S2')->getFont()->setSize(11);
                $sheet->getStyle('A3:S3')->getFont()->setSize(11);
                $sheet->getStyle('A4:S4')->getFont()->setSize(11);
                $sheet->getStyle('A5:S5')->getFont()->setSize(11);
                $sheet->getStyle('A6:S6')->getFont()->setBold(true)->setSize(11);
                
                $sheet->getColumnDimension('A')->setWidth(40);
                $sheet->getColumnDimension('B')->setWidth(30);
                $sheet->getColumnDimension('C')->setWidth(20);
                $sheet->getColumnDimension('D')->setWidth(20);

                $sheet->getColumnDimension('E')->setWidth(20);
                $sheet->getColumnDimension('F')->setWidth(20);
                $sheet->getColumnDimension('G')->setWidth(20);
                $sheet->getColumnDimension('H')->setWidth(20);
                $sheet->getColumnDimension('I')->setWidth(20);
                $sheet->getColumnDimension('J')->setWidth(20);
                $sheet->getColumnDimension('K')->setWidth(20);
                $sheet->getColumnDimension('L')->setWidth(20);
                $sheet->getColumnDimension('M')->setWidth(20);
                $sheet->getColumnDimension('N')->setWidth(20);

                
                $sheet->mergeCells('A1:Q1');
                $sheet->mergeCells('A2:Q2');
                $sheet->mergeCells('A3:Q3');
                $sheet->mergeCells('A4:Q4');
                $sheet->mergeCells('A5:Q5');
                $sheet->mergeCells('A6:Q6');
                if($model->is_vendor){
                $sheet->setCellValue(chr($i).$rowcount,  'Vendor');
                $i++;
                }
                if($model->vendor_mobile){
                $sheet->setCellValue(chr($i).$rowcount,  'Mobile No');
                $i++;
                }
                if($model->bill_date){
                    $sheet->setCellValue(chr($i).$rowcount,  'Date');
                    $i++;
                }
                if($model->bill_referance){
                   $sheet->setCellValue(chr($i).$rowcount,  'Ref.');
                   $i++;
                }
                if($model->bill_amount){
                    $sheet->setCellValue(chr($i).$rowcount,  'Amount');
                    $i++;
                 }
                 if($model->bill_paid_amount){
                    $sheet->setCellValue(chr($i).$rowcount,  'Paid');
                    $i++;
                 }
                 if($model->bill_unpaid_amount){
                    $sheet->setCellValue(chr($i).$rowcount,  'Pending');
                    $i++;
                 }
                 if($model->bill_bue_date){
                    $sheet->setCellValue(chr($i).$rowcount,  'Due date');
                    $i++;
                 }
                 if($model->bill_days){
                    $sheet->setCellValue(chr($i).$rowcount,  'Days');
                    $i++;
                 }
                 if($model->bill_notes){
                    $sheet->setCellValue(chr($i).$rowcount,  'Notes');
                    $i++;
                 }
                 if($model->bill_terms){
                    $sheet->setCellValue(chr($i).$rowcount,  'Terms');
                    $i++;
                 }
                 if($model->bill_over_due){
                    $sheet->setCellValue(chr($i).$rowcount,  'Over Due');
                    $i++;
                 }
                 if($model->bill_current_outstanding){
                    $sheet->setCellValue(chr($i).$rowcount,  'Current Outstanding');
                    $i++;
                 }
                 if($model->bill_total_outstanding){
                    $sheet->setCellValue(chr($i).$rowcount,  'Total Outstanding');
                    $i++;
                 }
                 $row=8;
                 $inv_amt=0;
                 $pending_amt=0;
                 $paid_amt=0; 
                 $days = 0;  
                 $amt_col;$paid_col;$pending_col;$curr_col;$outstanding_col;$overdue_col;
                 $dataProvider->pagination = false;              
                 foreach ($dataProvider->models as $data) {
                    // $inv_amt+=$data->amount;
                    // $pending_amt+=$data->pending;
                    // $paid_amt+=$data->paid;
                    $i=65;
                    $vendor = Vendor::find()->where(['business_name'=>$data->vendor_category])->one();
                    if($data->bill_id!='')
                    {
                       $bill = PurchaseBill::find()->where(['id'=>$data->bill_id])->one();
                    }

                    if($data->due_date!='')
                    {
                        $today= time();
                        $date = strtotime($data->due_date);
                        $diff= $date-$today;
                        $age = floor($diff/(60*60*24)).' Days';
                        if($age<0)
                         {
                            $final_age = -1 * (int)$age ;
                            $days = (int) $final_age;
                         }
                        else
                            $days = '0';
                    }
                    else
                       $days = '0';
          
                    $sheet->getStyle('A'.$row)->getAlignment()->setWrapText(true);
                    // $sheet->getStyle('S'.$row)->getAlignment()->setWrapText(true);
                  
                    if($model->is_vendor){
                        $sheet->getStyle(chr($i) . $row)->getAlignment()->setWrapText(true);
                        $sheet->setCellValue(chr($i) . $row, $data->vendor_category);

                         $i++;
                        }
                        
                        if($data->vendor_category!='')
                        {
                            if($model->vendor_mobile){
                            $sheet->setCellValue(chr($i) . $row, $vendor->mobile);
                            $i++;
                            }
                        }
                        else
                        {
                            if($model->vendor_mobile){
                            $sheet->setCellValue(chr($i) . $row, '');
                            $i++;
                            }
                        }
                        

                        if($data->bill_id!='')
                         {
                            if($model->bill_date){
                            $sheet->setCellValue(chr($i) . $row, date('d/m/Y', strtotime($data->date)));
                            $i++;
                            }
                         }
                         else
                         {
                            if($model->bill_date){
                            $sheet->setCellValue(chr($i) . $row,'');
                            $i++;
                            }
                         }


                         if($data->bill_id!='')
                         {
                            if($model->bill_referance){
                           $sheet->setCellValue(chr($i) . $row,$bill->vendor_bill_no);
                           $i++;
                           }
                         }
                         else
                         {
                            if($model->bill_referance){
                            $sheet->setCellValue(chr($i) . $row,'');
                            $i++;
                            }
                         }

                        
                        if($model->bill_amount){
                            if($data->bill_id!='')
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$bill->total));
                                $i++;
                            }
                            else
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->amount));
                                $i++;
                            }
                            
                         }
                         if($model->bill_paid_amount){


                            if($data->bill_id!='')
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($bill->total-($bill->pending_amount)), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                            else
                            {
                                $sheet->setCellValue(chr($i) . $row, preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->paid_amount));
                                $amt_col=$i;
                                $i++;
                            }  
                         }
                         if($model->bill_unpaid_amount){

                            if($data->bill_id!='')
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($bill->pending_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                            else
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($data->amount-$data->paid_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                         }
                         if($model->bill_bue_date){
                            $sheet->setCellValue(chr($i) . $row,  date('d/m/Y', strtotime($data->due_date)));
                            $pending_col=$i;
                            $i++;
                         }
                         if($model->bill_days){
                            $sheet->setCellValue(chr($i) . $row,  $days);
                            $i++;
                         }
                         if($data->bill_id!='')
                         {
                            if($model->bill_notes){
                            $sheet->setCellValue(chr($i) . $row,$bill->notes);
                            $i++;
                            }
                         }
                         else
                         {
                            if($model->bill_notes){
                            $sheet->setCellValue(chr($i) . $row,'');
                            $i++;
                            }
                         }

                         if($data->bill_id!='')
                         {
                            if($model->bill_terms){
                            $sheet->setCellValue(chr($i) . $row,$bill->terms);
                            $i++;
                         }
                         }
                         else
                         {
                            if($model->bill_terms){
                            $sheet->setCellValue(chr($i) . $row,'');
                            $i++;
                            }
                         }
                         
                         
                         if($model->bill_over_due){
                             if($data->bill_id!='')
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($bill->pending_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                            else
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($data->amount-$data->paid_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                         }
                         if($model->bill_current_outstanding){
                            $sheet->setCellValue(chr($i) . $row, '0.00');
                            $i++;
                         }
                         if($model->bill_total_outstanding){
                             if($data->bill_id!='')
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($bill->pending_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                            else
                            {
                                $sheet->setCellValue(chr($i) . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($data->amount-$data->paid_amount), 2, '.', '')));
                                $paid_col=$i;
                                $i++;
                            }
                         }
            
                  $row++;   
                 } 
               //   print_r($paid_amt);die();
                 // $sheet->setCellValue('A' . $row,'Total');
                 // if($model->is_amt)
                 // $sheet->setCellValue(chr($amt_col) . $row, (string)$inv_amt);
                 // if($model->is_paidamt)
                 // $sheet->setCellValue(chr($paid_col) . $row,(string)$paid_amt);
                 // if($model->is_unpaidamt)
                 // $sheet->setCellValue(chr($pending_col) . $row,(string)$pending_amt);
                 // if($model->is_currentoutstanding)
                 // $sheet->setCellValue(chr($curr_col) . $row,(string)$pending_amt);
                 // if($model->is_overdue)
                 // $sheet->setCellValue(chr($overdue_col) . $row,(string)$pending_amt);
                 // if($model->is_totaloutstanding)
                 // $sheet->setCellValue(chr($outstanding_col) . $row,(string)$pending_amt);


                ob_clean();
                ob_start();
     
                header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
                header('Content-Disposition: attachment; filename="OverdueInvoice.xls"'); // Write file to the browser 

                $writer->save('php://output');
                ob_flush();
                exit();

        }
    }

         return $this->render('index',[
            'dataProvider'=>$dataProvider,
            'model'=> $model,
        ]);
    }

    public function actionVendordetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Vendor::find()->limit(10)->all();
        else
        $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
        return json_encode($customerlist);
    }


    public function actionPdfexport()
    {   
        // $dataProvider = new ActiveDataProvider([
        //     'query' => PurchaseVendorLedger::find()->orderBy(['Date' => SORT_DESC]),
        // ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/purchase-outstanding-expense/pdfexport.php', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('Purchase_outstanding_expense.pdf.pdf', 'D');
    }

    // public function actionView($bill_id=null)
    // {
    //     if($bill_id=='' || $bill_id==null)
    //     {

    //     }
    //     else
    //     {
    //         $data=BillProducts::find()->where(['bill_id'=>$bill_id,'is_deleted'=>0])->all();
    //         $data1=BillDocuments::find()->where(['bill_id'=>$bill_id,'is_deleted'=>0])->all();
    //         return $this->render('users/purchase-billview', [
    //             'model' => $this->findModel($id),
    //             'products'=>$data,
    //             'documents'=>$data1,
    //         ]);
    //     }

    // }


}
