<?php

namespace backend\modules\reports\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use backend\modules\reports\models\StockAgingReport;
use backend\modules\master\models\Product;

class StockAgingReportController extends \yii\web\Controller
{
    public function actionIndex($print=null,$excel=null)
    {
    	$model = new StockAgingReport();
        $query=StockAgingReport::find();


        if($model->load(Yii::$app->request->get())){
            $query->andFilterWhere(['in','product_id',$model->searchproduct]);

            if($model->type){

                if($model->type=='Zero'){
                 $query->andFilterWhere(['<=','total',0]);
                } else{
                     $query->andFilterWhere(['>','total',0]);
            }  
        }
    }
    
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        if($print!='')
        {
            $this->actionExportpdf($dataProvider);
        }
        if($excel!='')
        {
          $this->actionExcelreport($dataProvider);
        }

        return $this->render('index', [
            'model' => $model,  
            'dataProvider' => $dataProvider,
        ]);
    }

    public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }

    public function actionExportpdf($data=null)
    {
        $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/stock-aging-report/exportpdf', [
                'dataProvider' => $data,

            ]));
            $mpdf->Output('Stock_ageing_analysis_summary.pdf', 'I');
    }


    public function actionExcelreport($mod=null)
    {  
      if($mod!='')
      {
         $dataProvider = $mod;
      } 
      else{
        $dataProvider = new ActiveDataProvider([
            'query' => StockAgingReport::find(),
         ]);
      }
      $dataProvider->pagination = false;
       $phpExcel = new \PHPExcel;
     
      $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      $sheet->getRowDimension('A1')->setRowHeight(35);
      $sheet ->getCell('A1')->setValue('Mohapatra Scientific Supply');
      $sheet ->getCell('A3')->setValue('MOHASYN');
      $sheet ->getCell('A4')->setValue('Bhuvaneshwar');
      $sheet ->getCell('A5')->setValue('Bhuvaneshwar,');
      $sheet ->getCell('A7')->setValue('Stock Ageing Analysis Summary');
      // Making headers text bold and larger
      $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A7:K7')->getFont()->setBold(true)->setSize(12);


      $sheet->getColumnDimension('A')->setWidth(30);
      $sheet->getColumnDimension('B')->setWidth(20);
      $sheet->getColumnDimension('C')->setWidth(15);
      $sheet->getColumnDimension('D')->setWidth(15);
      $sheet->getColumnDimension('E')->setWidth(15);
       $sheet->getColumnDimension('F')->setWidth(15);

      $sheet->mergeCells('A1:F1');
      $sheet->mergeCells('A2:F2');
      $sheet->mergeCells('A3:F3');
      $sheet->mergeCells('A4:F4');
      $sheet->mergeCells('A5:F5');
      $sheet->mergeCells('A6:F6');
      $sheet->mergeCells('A7:F7');

      $sheet->mergeCells('A8:B8');
      $sheet->setCellValue('A8',  'Item Details');
      $sheet->setCellValue('C8',  'Total');
      $sheet->setCellValue('D8',  '< 45 days');
      $sheet->setCellValue('E8',  '45 to 90 days');
      $sheet->setCellValue('F8',  '> 90 days');

      $sheet->getStyle('A8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('C8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('D8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('E8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('F8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
       $sheet->getStyle('A8')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('C8')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('D8')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('E8')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('F8')->getFont()->setBold(true)->setSize(12);

      $sheet->setCellValue('A9',  'Name');
      $sheet->setCellValue('B9',  'Selling Price');
      $sheet->setCellValue('C9',  'Quantity');
      $sheet->setCellValue('D9',  'Quantity');
      $sheet->setCellValue('E9',  'Quantity');
      $sheet->setCellValue('F9',  'Quantity');

      $sheet->getStyle('A9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('B9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('C9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('D9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('E9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('F9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      
      
        $row=10;
        $amount =0;
        $total =0;
        $total_produt_less_45 =0;
        $total_produt_less_90 =0;
        $total_produt_greater_90 =0;
        foreach ($dataProvider->models as $data) {

         $sheet->getStyle('A'.$row)->getAlignment()->setWrapText(true);   
         if($data->total=='')
         {
            $amount = 0;
            $total = $total+0;
         }   
         else
         {
            $amount = $data->total;
            $total = $total + $data->total;
         }
         $amount = (string)$amount;

         $total_produt_less_45 = $total_produt_less_45 + $data->fourtyfive_days;
         $total_produt_less_90 = $total_produt_less_90 + $data->fourtyfive_ninty_days;
         $total_produt_greater_90 = $total_produt_greater_90 + $data->ninty_days;

        $sheet->getStyle('C'.$row)->getAlignment()->setWrapText(true);
        $sheet->getStyle('D'.$row)->getAlignment()->setWrapText(true);
        $sheet->setCellValue('A' . $row,  $data->product_name);
        $sheet->setCellValue('B' . $row,  $data->selling_price);
        $sheet->setCellValue('C' . $row,  $amount);    
        $sheet->setCellValue('D' . $row,  (string)$data->fourtyfive_days); 
        $sheet->setCellValue('E' . $row,  (string)$data->fourtyfive_ninty_days); 
        $sheet->setCellValue('F' . $row,  (string)$data->ninty_days); 
        $row++;   

       } 

       $sheet->setCellValue('A' . $row, 'Grand Total');
        $sheet->setCellValue('B' . $row,  '');
        $sheet->setCellValue('C' . $row,  (string)$total); 
        $sheet->setCellValue('D' . $row,  (string)$total_produt_less_45); 
        $sheet->setCellValue('E' . $row,  (string)$total_produt_less_90); 
        $sheet->setCellValue('F' . $row,  (string)$total_produt_greater_90); 


      ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="Stock_ageing_analysis_summary.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
    }



}
