<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "inventory_closing_stock".
 *
 * @property string|null $product_id
 * @property string $product_name
 * @property int|null $stock_unit
 * @property float|null $inward
 * @property float|null $outward
 * @property float|null $value
 */
class CompilationStockReport extends \yii\db\ActiveRecord
{
    public $product_name;
    public $from_date;
    public $to_date;
    public $product_category;
    public $vendor_name;
    public $closing;

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'compilation_stock_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
           
            [['product_id', 'vendor_id'], 'integer'],
            [['from_date', 'to_date', 'avg_price', 'amount','selling_price'], 'safe'],
            [['inward', 'outward', 'value', 'status', 'opening_balance', 'closing'], 'number'],
            [['product_name', 'product_category', 'vendor_name'], 'string', 'max' => 512],
            
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'product_id' => 'Product ID',
            'product_name' => 'Product Name',

            'inward' => 'Inward',
            'outward' => 'Outward',
            'amount' => 'Amount',
        ];
    }
}
