<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "nagative_stock".
 *
 * @property string|null $product_name
 * @property string $category
 * @property float|null $selling_price
 * @property string|null $vendor
 * @property float|null $inward_amount
 * @property float|null $outward_amount
 * @property float|null $outstanding_amount
 * @property float|null $opening_stock
 */
class NagativeStock extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'nagative_stock';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_name'], 'string'],
            [['category'], 'required'],
            [['selling_price', 'inward_amount', 'outward_amount', 'outstanding_amount','opening_stock'], 'number'],
            [['category', 'vendor'], 'string', 'max' => 512],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'product_name' => 'Product Name',
            'category' => 'Category',
            'selling_price' => 'Selling Price',
            'vendor' => 'Vendor',
            'inward_amount' => 'Inward Amount',
            'outward_amount' => 'Outward Amount',
            'outstanding_amount' => 'Outstanding Amount',
            'opening_stock' => 'Opening Stock',
        ];
    }
}
