<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "overdue_invoice_report".
 *
 * @property string|null $customer_name
 * @property string|null $executive
 * @property string|null $invoice_id
 * @property string|null $status
 * @property string|null $date
 * @property float|null $amount
 * @property float|null $paid
 * @property float|null $pending
 * @property string|null $due_days_crossed
 * @property string|null $due_date
 * @property int|null $due_days
 */
class OverdueInvoiceReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $c_name;
    public $creator;
    public $exe;
    public $c_type;
    public $order;
    public $is_customer;
    public $is_invoiceid;
    public $is_mobile;
    public $is_phone;
    public $is_date ;
    public $is_amt;
    public $is_paidamt;
    public $is_unpaidamt;
    public $is_duedate;
    public $is_days;
    public $is_executives;
    public $is_notes;
    public $is_terms;
    public $is_currentoutstanding;
    public $is_overdue;
    public $is_totaloutstanding;


    public static function tableName()
    {
        return 'overdue_invoice_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['date', 'due_date','from_date','to_date','c_name','creator','exe','c_type','order','is_invoiceid','is_customer','is_mobile','is_phone','is_date','is_amt','is_paidamt','is_unpaidamt','is_duedate','is_days','is_executives','is_notes','is_terms','is_currentoutstanding','is_overdue','is_totaloutstanding'], 'safe'],
            [['amount', 'paid', 'pending'], 'number'],
            [['due_days'], 'integer'],
            [['customer_name', 'executive', 'invoice_id', 'status'], 'string', 'max' => 254],
            [['due_days_crossed'], 'string', 'max' => 19],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'customer_name' => 'Customer Name',
            'executive' => 'Executive',
            'invoice_id' => 'Invoice ID',
            'status' => 'Status',
            'date' => 'Date',
            'amount' => 'Amount',
            'paid' => 'Paid',
            'pending' => 'Pending',
            'due_days_crossed' => 'Due Days Crossed',
            'due_date' => 'Due Date',
            'due_days' => 'Due Days',
        ];
    }
}
