<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "purchase_vendor_ledger".
 *
 * @property string|null $Date
 * @property string|null $vendor_type
 * @property float|null $total_debit_amount
 * @property float|null $total_credit_amount
 * @property string|null $ledgerhead_id
 */
class PurchaseVendorLedger extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $type;
    public $group;
    public $sort_by;
    public $balance;
    public $ledger_id;

    public $details_from_date;
    public $details_to_date;
    public $details_type;
    public $details_notes;
    public $details_user;
    public $details_ref;
    public $details_total_from;
    public $details_total_to;


    public static function tableName()
    {
        return 'purchase_vendor_ledger';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date','from_date','to_date','details_from_date','details_to_date'], 'safe'],
            [['total_debit_amount', 'total_credit_amount','details_total_from','details_total_to'], 'number'],
            [['vendor_type','sort_by','balance','group','type','ledger_id','details_type'], 'string', 'max' => 254],
            [['ledgerhead_id','details_user'], 'string', 'max' => 255],
            [['details_notes','details_ref'], 'string'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'vendor_type' => 'Vendor Type',
            'total_debit_amount' => 'Total Debit Amount',
            'total_credit_amount' => 'Total Credit Amount',
            'ledgerhead_id' => 'Ledgerhead ID',
        ];
    }
}
