<?php

namespace backend\modules\reports\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\reports\models\SaleReportByProduct;

/**
 * AccountingLedgerSearch represents the model behind the search form of `backend\modules\master\models\AccountingLedger`.
 */
class SaleReportByProductSearch extends SaleReportByProduct
{
    /**
     * {@inheritdoc}
     */
    public $order_by;
    public $date_range;
    public $from_date;
    public $to_date;
    public $report_type;


    public function rules()
    {
        return [
            [['Date','Particulars', 'VChNo', 'GSTNo', 'product_name', 'Qty', 'Rate','GrossTotal','TaxAmount','VendorDEALER','Units','Description','Category','Executive','customer_type','date_range','report_type','order_by','created_by','from_date','to_date'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query =SaleReportByProduct::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort'=> ['defaultOrder' => ['sale_product_id' => SORT_DESC]],

        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        //grid filtering conditions
        //$query->andFilterWhere([
        //    'Executive' => $this->Executive,
        //    'Category' => $this->Category,
        //    'product_name' => $this->product_name,
       //     'group_name_id' => $this->group_name_id,
        //     'account_type_id' => $this->account_type_id,
        //     'opening_balance' => $this->opening_balance,
        //     'msic_code' => $this->msic_code,
        //     'created_at' => $this->created_at,
        //     'updated_at' => $this->updated_at,
        //]);

        // $query->andFilterWhere(['like', 'Executive', $this->Executive])
        //       ->andFilterWhere(['like', 'product_name', $this->product_name])
        //       ->andFilterWhere(['like', 'Category', $this->Category])
        //       ->andFilterWhere(['like', 'customer_type', $this->customer_type])
        //       ->andFilterWhere(['like', 'Particulars', $this->Particulars])
        //       ->andFilterWhere(['like', 'VendorDEALER', $this->VendorDEALER]);
        //      // ->orFilterWhere(['like', 'Date', date('Y-m-d')]);
        //     if($this->Date=='today'){
        //         $query->andFilterWhere(['like', 'Date', date('Y-m-d')]);
        //     }

        return $dataProvider;
    }
}