<?php

namespace backend\modules\reports\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\reports\models\SalesCustomerLedger;

/**
 * AccountingLedgerSearch represents the model behind the search form of `backend\modules\master\models\AccountingLedger`.
 */
class SalesCustomerLedgerSearch extends SalesCustomerLedger
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $order_by;
    public $ledger_balance;

    public function rules()
    {
        return [
            [['total_debit_amount', 'total_credit_amount','ledgerhead_id','from_date','to_date','executive','customer_type','account_type_id','group_name_id','order_by','ledger_balance'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query =SalesCustomerLedger::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => false,

        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        //grid filtering conditions

        return $dataProvider;
    }
}