<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "sales_fast_slow_moving_report".
 *
 * @property string|null $product_id
 * @property string|null $product_name
 * @property string|null $description
 * @property float|null $product_sold
 * @property string|null $units
 * @property string|null $category
 * @property string|null $vendor_name
 * @property int|null $vendor_id
 */
class SalesFastSlowMovingReport extends \yii\db\ActiveRecord
{



    public $from_date;
    public $to_date;
    public $type;
    public $v_name;
    public $cat;
    public $prod_code;
    public $row;

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sales_fast_slow_moving_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['from_date','to_date'],'safe'],
            [['description'], 'string'],
            [['product_sold'], 'number'],
            [['vendor_id'], 'integer'],
            [['product_id', 'vendor_name','v_name','prod_code','type','row'], 'string', 'max' => 254],
            [['product_name'], 'string', 'max' => 512],
            [['units'], 'string', 'max' => 32],
            [['category','cat'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'product_id' => 'Product ID',
            'product_name' => 'Product Name',
            'description' => 'Description',
            'product_sold' => 'Product Sold',
            'units' => 'Units',
            'category' => 'Category',
            'vendor_name' => 'Vendor Name',
            'vendor_id' => 'Vendor ID',
        ];
    }
}
