<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Vendor Ledger';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
     body
  {
    font-size: 15px;
  }
table, th, td {
  border: 1px solid #CDCBCB;
  border-collapse: collapse !important;

}
table{
    width:100%;
}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
th
{
  text-decoration-color: black;  
  background-color: #CDCBCB;
  border: none;
}
td
{
  border: 1px solid #CDCBCB;
}
</style>
<?php
$total_inflow=0;$total_outflow=0;
if (!empty($dataProvider1->getModels())) {
    foreach ($dataProvider1->getModels() as $key => $val) {
        $total_inflow+=$val->total_amount;
    }
}
if (!empty($dataProvider2->getModels())) {
    foreach ($dataProvider2->getModels() as $key => $val) {
        $total_outflow+=$val->total_amount;
    }
}
?>
    <h5 style="text-align:center"><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong></h5>
    <h5 style="text-align:center">F2G/30, INDRADHANU MARKETIRC VILLAGE,</h5>
    <h5 style="text-align:center;">BHUBANESWAR,</h5>
    <h5 style="text-align:center">Cash Flow Reports</h5>
    <h5 style="text-align:center">
      <?php
         if($model->from_date!='' && $model->to_date!='')
         {
           echo  date('F j Y', strtotime($model->from_date))." to ".date('F j Y', strtotime($model->to_date));
         }
         else
         {

         }
      ?>
    </h5>
            <?= GridView::widget([
                'dataProvider' => $dataProvider1,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [                    
                    [
                        'label'=>'Inflow',
                        'value'=>function($data){
                            $customer=Customer::find()->where(['id'=>$data->customer_name])->one();
                            return $customer?$customer->business_name:$data->customer_name;
                            },
                            'footer'=>'Total',
                    ],
                    
                    [
                        'value'=>function($data){
                            return $data->total_amount;
                        },
                        'footer'=>$total_inflow,
                    ],
                    

                ],
            ]); ?> 
           

                        <?= GridView::widget([
                'dataProvider' => $dataProvider2,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    
                    [
                        'label'=>'Outflow',
                        'value'=>function($data){
                            return Vendor::find()->where(['id'=>$data->vendor_id])->one()->business_name;
                            // return $data->vendor_id;
                        },
                        'footer'=>'Total',


                    ],
                    
                    [
                        'headerOptions' => [
                            'style' => 'display: none;',
                        ],
                        'value'=>function($data){
                            return $data->total_amount;
                        },
                        'footer'=>$total_outflow,
                    ],
                    

                ],
            ]); ?>
            <br>
            <table class="table table-striped table-bordered" >
            <tr id="row1">
					<td class="table_innerbg3"  width="25%"><b>Inflow Total</b></td>
					<td class="table_innerbg4" width="25%"><b><?=$total_inflow?></b></td>
					<td class="table_innerbg3" width="25%"><b>Outflow Total</b></td>
					<td class="table_innerbg4" width="25%"><b><?=$total_outflow?></b></td>
					</tr>
                    <tr>
						<td colspan="3" class="table_innerbg3 des08" width="70%" style="color:#FF0000"><b>Net Flow</b></td>
						<td class="table_innerbg4 des08" style="color:#FF0000"><b><?= $total_inflow-$total_outflow?></b></td>
					</tr>
            </table>