<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use backend\modules\master\models\Product;
use backend\modules\master\models\CallStatus;
use backend\modules\master\models\BusinessType;
use backend\modules\master\models\LeadExecutive;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\GroupName;
use backend\modules\master\models\AccountType;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\LeadsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'General Ledger Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
@media print {
        .dj-adv-search-row,.summary,.pagination{
            display: none !important;
        }

        .dj-print-sec {
            display: none !important;
        }

        .widget-content-wrapper {
            display: none !important;
        }

        .table-responsive {
            overflow: hidden;
        }

        .app-header__menu {
            display: none !important;
        }

        .print_header {
            display: block;
            color: black;
            font-size: 15px;
        }

        .table {
            border: 2px solid #000;
        }

        .table td {
            border: 2px solid #000 !important;
        }

        .table th {
            border: 2px solid #000 !important;
        }

    }
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                <div class="card">
                    <div class="no-gutters row">
                        <div class="col-md-12 col-lg-12">
                            <ul class="list-group list-group-flush">
                                <li class="bg-transparent list-group-item">
                                    <div class="widget-content p-0">
                                        <div class="widget-content-outer">
                                            <div class="widget-content-wrapper">
                                                <div class="widget-content-left">
                                                    <div class="widget-numbers dj-text-success">General Ledger Report</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                
                            </ul>
                        </div>
                        
                    </div>
                </div>
            </div>
            <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get','options' => []]); ?>
						   <div class="row dj-adv-search-row">
						   <div class="col-md-4">
                               <div class="position-relative form-group" >
                               <?= $form->field($model, 'search')->textInput(['maxlength' => true,'class'=>"form-control",'placeholder'=>"Ledger Name/Account Id"])->label(false) ?>
                              </div>
                            </div>
							<div class="col-md-2">
                            <button class="search_field_buttons"><i class="fa fa-search"></i> Search</button>

								<!-- <a href="#" class="btn btn-rounded dj-adv-search"><i class="fa fa-search"></i> Search</a> -->
							</div>
                            <?php ActiveForm::end(); ?>
							<div class="col-md-3">
							<a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            
							</div>
                            <div class="col-md-1">
                            <a class="search_field_buttons" href="<?=Url::base().'/reports/general-ledger-report/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type='button' title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true" ></i></a>
                            </div>
                            <div class="col-md-2">
                            <!-- <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                    <a href="<?= Url::current() ?>&print=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>Print</button></a>
                                                <?php } else { ?>
                                                    <a href="<?= Url::current() ?>?print=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>Print</button></a>
                                                <?php } ?> -->

                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                    <a href="<?= Url::current() ?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else { ?>
                                                    <a href="<?= Url::current() ?>?excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?> 

                            </div>
						   </div>
									<!-- <form class="dj-sale-form collapse" id="search-look"> -->
                                    <?php $form = ActiveForm::begin(['method' => 'get','options' => ['class'=>"dj-sale-form collapse",'id' => 'search-look']]); ?>

                                        <div class="form-row" id="advance-details">
										
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Sort By</label>
                                                    <?= $form->field($model, 'sort_by') ->dropDownList(['Debit # Asc'=>'Debit # Asc','Debit # Dsc'=>'Debit # Dsc','Credit Asc'=>'Credit Asc','Credit Dsc'=>'Credit Dsc'],['prompt'=>'--Select--','class' => " select_class form-control",])->label(false)?>
                                                </div>
												
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Ledger Balance</label>
                                                    <?= $form->field($model, 'ledg_bal')->dropdownList([
                                                                'non_zero_ledger' => 'Non Zero Ledger', 
                                                                'zero_ledger' => 'Zero Ledger',
                                                            ],
                                                            ['prompt'=>'--Select--','class'=>'form-control lead_type']
                                                        )->label(false) ?>
                                                </div>
												
                                            </div>
											
                                            <div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                            <!-- <a href="#" class="btn btn-primary btn-rounded dj-search"><i class="fa fa-search"></i> -->
											<button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i> Search</button>
											</div>
                                            
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
                <!-- <div class="main-card mb-5 card"> -->
            <!-- <div class="card-body"> -->
            <!-- <div class="row"> -->
           
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            // 'filterModel' => $searchModel,
            'columns' => [
            //    ['class' => 'yii\grid\CheckboxColumn'],
                
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Ledger Name',
                    'attribute'=>'ledgerhead_id',
                    'format'=>'raw',
                   'value'=> function($data){
                    //    return $data->ledgerhead_id;
                       if($data->ledgerhead_id)

                            //$ledger = AccountingLedger::find()->where(['ledger_id'=>$data->ledgerhead_id])->one();
			    if($data->from=='vendor ledger')
                            {
                                $ledger = AccountingLedger::find()->where(['ledger_id'=>$data->ledgerhead_id])->andWhere(['group_name_id'=>29])->one();
                            }
                            else{
                                $ledger = AccountingLedger::find()->where(['ledger_id'=>$data->ledgerhead_id])->one();
                            }
                            if($ledger)
                            {
                                $led_details = '<a class="nav-link" href='.Url::base().'/reports/general-ledger-report/generalledger-details?id='."$ledger->accounting_ledger_id".' data-method=post>'.$data->ledgerhead_id.' </a>';
                            }
                            else{
                                $led_details = $data->ledgerhead_id;
                            }
                       
				        return $led_details;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057','width:1000px'],
		    'contentOptions'=>[ 'style'=>'text-align:right'],
                    'header'=> 'Debit(Rs.)',
                    'attribute'=>'total_debit_amount',
                   'value'=> function($data){
		       return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->total_debit_amount), 2, '.', '')));
                       //return $data->total_debit_amount;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057','width:70px'],
		    'contentOptions'=>[ 'style'=>'text-align:right'],
                    'header'=> 'Credit(Rs.)',
                    'attribute'=>'total_credit_amount',
                   'value'=> function($data){
		        return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->total_credit_amount), 2, '.', '')));
                       //return $data->total_credit_amount;
                   }

                ],

            ],       
        ]); ?>
            </div>
        </div>
    </div>
    <?php ob_start();?>
 <script type="text/javascript">

<?php if ($print == 'true') { ?>
        window.print();
        return false;
    <?php } ?>


$(function() {
$('input[name="LeadsSearch[lead_date]"]').attr('type','date');
 $('input[name="LeadsSearch[lead_date]"]').attr('style','width:95px');
$('input[name="LeadsSearch[postponed_date]"]').attr('type','date');
$('input[name="LeadsSearch[postponed_date]"]').attr('style','width:95px');
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
