<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use common\models\User;
use backend\modules\master\models\Vendor;
use kartik\grid\GridView;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'GST-3B Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<?php
//print_r($from);die();
?>
<style>
    #search{
        margin-top: 30px;
    }
</style>

<div class="container mt-5">
    <div class="row">
    <div class="col-md-12">
    <h3><b>GSTR-3B</b></h3>
    </div>
    </div>
    <div class="row mb-3">
        <div class="col-md-4">
            <button class="btn btn-primary" style="display:none">Advanced search</button>
        </div>
        <div class="col-md-8">
            <a href="<?=Url::base().'/reports/gst-report/index'?>" class="btn btn-primary float-right mx-2"><i class="fa fa-long-arrow-left">&nbsp;Back</i></a>
            <a href="<?=Url::base().'/reports/gst-report/gstr3b?from_date='.$from_date.'&to_date='.$to_date?>" class="btn btn-primary float-right"><i class="fa fa-cloud-upload">&nbsp;Form 3B</i></a>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <div class="card p-4">
                <?php $form = ActiveForm::begin(['method'=>'get','action' => Url::to(['gst-report/gstr3'])]); ?>
                <div class="row">
                <!-- <label>From period</label> -->
                <div class="col-md-3">
                <?php if($searchModel->from_date){?>
                <?= $form->field($searchModel, 'from_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date'])->label('From Period') ?>
                <?php } else {?>
                <?= $form->field($searchModel, 'from_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date', 'value'=>date('Y-m', strtotime($from_date))])->label('From Period') ?>
                <?php } ?>
                </div>
                <!-- <label>To period</label> -->
                <div class="col-md-3">
                <?php if($searchModel->to_date){?>
                <?= $form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date1'])->label('To Period') ?>
                <?php } else{ ?>
                <?= $form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control date" ,'id'=>'date1', 'value'=>date('Y-m', strtotime($to_date))])->label('To Period') ?>
                <?php } ?>
                </div>
                <div class="col-md-3">
                <button class="btn btn-primary" id="search"><i class="fa fa-search">&nbsp;search</i></button>
                </div>      
                </div>
                <?php ActiveForm::end(); ?>
            </div>
        </div>   
    </div>
    <div class="row mt-3">
        <div class="col-12">
            <div class="card p-4 text-center">
                <div><h5><b> GSTR-3B Summary</b></h5></div>
                <div><strong>Mohapatra Scientific Supply</strong></div>
                <div><strong>Period from <?=date('F-y',strtotime($from));?>
                
                to <?=date('F-y',strtotime($to));?></strong></div>
                <table style="width:100%" class="table table-bordered table-striped mt-3">
        <tr>
            <th class="text-left">Supply Type</th>
            <th class="text-right">Amount(Rs)</th> 
            <th class="text-right">Tax(Rs)</th>
        </tr>
        <tr>
            <td class="text-left"><a href="<?=Url::base().'/reports/gst-report/gstr1?from_date='.$from_date.'&to_date='.$to_date?>">Outward Supplies</a></td>
            <?php if($total_amt_outward){?>
            <td class="text-right">Rs&nbsp;<?= number_format("$total_amt_outward",2)."<br>"?></td>
            <?php } else{ ?>
            <td class="text-right">Rs 0.00</td>
            <?php } if($total_tax_outward){ ?>
            <td class="text-right">Rs&nbsp;<?= number_format("$total_tax_outward",2)."<br>"?></td>
            <?php } else{?>
            <td class="text-right">Rs 0.00</td>
            <?php }?>

        </tr>
        <tr>
            <td class="text-left"><a href="<?=Url::base().'/reports/gst-report/gstr2?from_date='.$from_date.'&to_date='.$to_date?>">Inward Supplies</a></td>
            <?php if($total_amt_inward){?>
            <td class="text-right">Rs&nbsp;<?=number_format("$total_amt_inward",2)."<br>"?></td>
            <?php } else{?>
            <td class="text-right">Rs 0.00</td>
            <?php } if($total_tax_inward){?>
            <td class="text-right">Rs&nbsp;<?=number_format("$total_tax_inward",2)."<br>"?></td>
            <?php } else{ ?>
            <td class="text-right">Rs 0.00</td>
            <?php } ?>
        </tr>
        <tr>
            <td class="text-left"><strong>Net GST Payable</strong></td>
            <td></td>
            <td class="text-right">Rs&nbsp;<?=$total_tax_outward-$total_tax_inward?></td>
        </tr>
        </table>
            </div>
        </div>    
    </div>
</div>

<?php ob_start();?>
<script language="JavaScript" type="text/javascript">
  $('#date').attr('type','month');
  $('#date1').attr('type','month');
//   $('#search').click(function() {
//     //alert(1);
//     var to = $('#date').val();
//     //alert(to);
//     var from = $('#date1').val();
//     window.location.href = "<?//= Url::base(); ?>/reports/gst-report/gstr?to_date=" + to + "&from_date=" + from;
//   });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
