<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Vendor;
?>
<?php
$this->title = 'Invoices missing in supplier ledger';
?>
<?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Invoices missing in supplier's ledger</div>
                                        </div>
                                        <div class="widget-content-right">
                                        <?php if($till_date || $model->till_date){
                                            if($till_date){
                                            $date=$till_date;    
                                            }else{
                                            $date=$model->till_date;
                                            }  
                                            ?>
                                            <a href="<?=Url::base().'/reports/gst-report2/index?date='.$date ?>" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a></div>
                                       <?php }else{ ?>
                                        <a href='<?=Yii::$app->request->referrer?>' class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a></div>
                                      <?php  } ?>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-6">
                <?php $form = ActiveForm::begin(['method' => 'get','action' => Url::to(['gst-report2/details']),]); ?>
                <label for="notes">From Period</label>
                <?php if($model->till_date){?>
                <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                <?php }elseif($till_date){?>
                    <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control",'value'=>date('Y-m', strtotime($till_date))])->label(false) ?>
                <?php }else{?>
                    <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control",'value'=>date('Y-m', strtotime('0 month'))])->label(false) ?>
                <?php } ?>
                </div>
                <div class="col-md-3 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>
                    <div class="col-md-3 dj-btn-align djsec-text-right">
                    <a  class="search_field_buttons"  href="<?=Url::base().'/reports/gst-report2/details'?>" role="button" aria-expanded="false" aria-controls="search-look" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                    </div>
                <?php ActiveForm::end(); ?>
            </div>
           
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => false,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                // 'pager' => [
                //     'firstPageLabel' => 'First',
                //     'lastPageLabel'  => 'Last'
                // ],
                'columns' => [
                    
                    [
                        'label'=>'Status',
                        'format'=>'raw',
                        'value'=> function($data) {
                            if($data['pending_amount']==0)
                            {
                             return '<span class="label-paid">PAID</span>';
                         }
                         //    else if($total<$data->total && $total!=0)
                            else if(($data['total']-($data['pending_amount']))>0)
                            {
                             return '<span class="label-partial">PARTIAL</span>';
                         }
                         //    else if($total==0)
                            else if($data['total']==($data['pending_amount']))
                            { 
                             return '<span class="label-draft">PENDING</span>';
                         }
                    }
                    ],
                    [
                         'label'=> 'Supplier Name/GSTIN	',
                        'value' => function($data){
                            $vendor=Vendor::find()->where(['id'=>$data['vendor_id']])->one();
                            if($vendor->gstin_no){
                                return  $vendor->business_name .', '.$vendor->gstin_no;
                            }else{
                                return  $vendor->business_name;
                            }
                        }
                    ],
                    [
                        'label'=> 'Invoice No',
                        'value' => function($data){
                            return $data['bill_no'];

                        }
                    ],
                    [
                        'label'=> 'Invoice Date',
                        'value' => function($data){
                            return date(("\ F j  Y"), strtotime($data['date']));
                        }
                    ],
                    [
                        'label'=> 'Invoice Value',
                        'value' => function($data){
                            return $data['total'];

                        }
                    ],
                    [
                        'label'=> 'Taxable Value',
                        'value' => function($data){
                            return $data['subtotal'];

                        }
                    ],
                    [
                        'label'=> 'IGST',
                        'value' => function($data){
                            return $data['igst']?$data['igst']:0;

                        }
                    ],
                    [
                        'label'=> 'CGST',
                        'value' => function($data){
                            return $data['cgst']?$data['cgst']:0;

                        }
                    ],
                    [
                        'label'=> 'SGST',
                        'value' => function($data){
                            return $data['sgst']?$data['sgst']:0;

                        }
                    ],
                    [
                        'label'=> 'Remarks',
                        'value' => function($data){
                            return $data['notes'];

                        }
                    ],
                    

                ],
            ]); ?>            
        </div>
    </div>
</div>
<?php ob_start();?>
 <script type="text/javascript">
$(function() {

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>