<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Vendor;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\users\models\PurchaseBill;
use backend\modules\master\models\PurchaseOrder;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\PurchaseBillSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$this->title = 'Reconcile GSTR-2A';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Reconcile GSTR-2A</div>
                                        </div>
                                        <div class="widget-content-right">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
        <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-6">
                <?php $form = ActiveForm::begin(['method' => 'get','action' => Url::to(['gst-report2/index']),]); ?>
                <label for="notes">From Period</label>
                <?php if($model->till_date){?>
                <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                <?php } elseif($date) {?>
                    <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control ",'value'=>date('Y-m', strtotime($date))])->label(false) ?>
                <?php } else{?>
                    <?= $form->field($model, 'till_date')->textInput(['type'=>'month','maxlength' => true,'class'=>"form-control",'value'=>date('Y-m', strtotime('0 month'))])->label(false) ?>
                <?php } ?>
                </div>
                <div class="col-md-3 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>
                    <div class="col-md-3 dj-btn-align djsec-text-right">
                    </div>
                <?php ActiveForm::end(); ?>
            </div>
           
        </div>
    </div>
    <div class="card col-md-6" >
  <div class="card-body">
    <?php
    if($model->till_date){?>
            <a href="<?=Url::base().'/reports/gst-report2/details?till_date='.$model->till_date?>"><h5 class="card-title">Invoices missing in supplier's ledger</h5></a>
    <?php }elseif ($date) { ?>
        <a href="<?=Url::base().'/reports/gst-report2/details?till_date='.$date?>"><h5 class="card-title">Invoices missing in supplier's ledger</h5></a>
   <?php }else{?>
        <a href="<?=Url::base().'/reports/gst-report2/details'?>"><h5 class="card-title">Invoices missing in supplier's ledger</h5></a>
    <?php }
    ?>
    <hr>
    <h6 class="card-subtitle mb-2 text-muted">Total Transactions: <?=$total_transaction?>, Pending: <?=$total_transaction?></h6>
    <p class="card-text"><strong> Taxable Value:</strong> Rs <?=number_format((float)$taxable_value, 2, '.', '');?> <br><strong>Tax Amount:</strong> Rs <?= number_format((float)$tax_amount, 2, '.', '');?> </p>
  </div>
</div>
                        