<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<?php


$total_qty=0;$total_gross=0;$total_tax=0;$total_bill=0;$total_paid=0;$total_other=0;
if (!empty($dataProvider->getModels())) {
    foreach ($dataProvider->getModels() as $key => $val) {
      $total_qty+=$val->qty;
        $total_gross+=$val->gross_total;
        $total_tax+=$val->tax_amount;
        $total_bill+=$val->bill_total;
        $total_paid+=$val->paid_amount;
        $total_other+=$val->other_charges;
    }

}
?>
<style>
    table, th, td {
        border: 1px solid black !important;
        border-collapse: collapse !important;

    }
    th, td {
        padding: 5px !important;
        text-align: left !important;
        color:black !important;

    }
    th{
        border:none;
        background-color:slategray;
    }
</style>
<p style="text-align: center"><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong>
<br>
<br>F2G/30, INDRADHANU MARKETIRC VILLAGE, <br>BHUBANESWAR</p>
<h1 style="text-align:center">Purchase Report</h1>
<?= GridView::widget([
    'dataProvider' => $dataProvider,
    'showFooter' => true,
    'footerRowOptions'=>['style'=>'font-weight:bold;'],
    'columns' => [
        ['class' => 'yii\grid\SerialColumn'],
        [
                'label'=>'Date',
                 'value'=> function($data){
                    return Yii::$app->formatter->asDate($data->Date,'long');
                 }
        ],
        [    'label'=>'Vendor Name',
            'value' => function($data) {
                return $data->vendor_name;
            },
        ],
        [
                'label'=>'VCH No',
                 'value'=> function($data){
                 return $data->vch_no;
            }
        ],
        //'vendor_bill_no',
        [
                'label'=> 'Vendor Bill#',
                 'value'=> function($data){
                            return $data->vendor_bill_no;
                 }
        ],
       // 'gst_no'
        [
                'label'=>'TIN/Purchase Tax No',
            'value'=> function($data){
                    return $data->gst_no;
            }
        ],
        //'qty',
        [
                'label'=> 'QTY',
                'value'=> function($data){
                     return $data->qty;
                },
            'footer'=> $total_qty
        ],
        //'rate',
        [
                'label'=> 'Rate',
            'value'=> function($data){
                    return $data->rate;
            }
        ],
        [
            'label'=> 'Gross Total',
            'value'=> function($data){
                return $data->gross_total;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($total_gross,2),'INR')
        ],
        [
            'label'=> 'Tax Amount',
            'value'=> function($data){
                return $data->tax_amount;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($total_tax,2),'INR')
        ],
        [
            'label'=> 'Other Charges',
            'value'=> function($data){
                return $data->other_charges;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($total_other,2),'INR')
        ],
        [
            'label'=> 'Bill Total',
            'value'=> function($data){
                return $data->bill_total;
            },
            'footer'=> Yii::$app->formatter->asCurrency(round($total_bill,2),'INR')
        ],
        [
            'label'=> 'Category',
            'value'=> function($data){
                return $data->category;
            }
        ],
        [
                'label'=> 'Paid Amount',
                  'value'=> function($data){
                        return $data->paid_amount;
                  },
            'footer'=> Yii::$app->formatter->asCurrency(round($total_paid,2),'INR')
        ],
        [
            'label'=> 'Paid Date',
            'value'=> function($data){
                return $data->bill_date;
            }
        ],
        [
             'label'=> 'Cheque Ref',
            'value'=> function($data){
                     return $data->cheque_ref;
            }
        ],
        [
                'label'=> 'User',
                'value'=> function($data){
                        if($data->user_id != null){
                            $user = User::find()->where(['=','id',$data->user_id])->one();
                            return $user->username;
                        }else{
                            return "";
                        }


                }
        ],

    ],

]); ?>


</div>
</div>
</div>
